﻿/*  ----------------------------------------------------------------------------
 *  Emergint Technologies, Inc.
 *  ----------------------------------------------------------------------------
 *  Epi Info™ - Web Analysis & Visualization
 *  ----------------------------------------------------------------------------
 *  File:       CanvasDto.cs
 *  Namespace:  Ewav    
 *
 *  Author(s):  Daniel Shorter, Mohammad Usman, Ninad Date, Sachin Agnihotri 
 *  Created:    26/08/2013    
 *  Summary:	no summary     
 *  ----------------------------------------------------------------------------
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using System.Text;
using Ewav.DTO;

namespace Ewav
{
    /// <summary>
    /// This Class will act as a communicating object between client and Server.
    /// </summary>
    public class CanvasDto
    {

        private int datasourceID;
        private DateTime createdDate;
        private DateTime modifiedDate; 


        /// <summary>
        /// Gets or sets the meta datasource ID.
        /// </summary>
        /// <value>The meta datasource ID.</value>
        public int   DatasourceID
        {
            get
            {
                return this.datasourceID;
            }
            set
            {
                this.datasourceID = value;
            }
        }

        private string datasource;

        /// <summary>
        /// Sets and gets datasource Name
        /// </summary>
        public string Datasource
        {
            get { return datasource; }
            set { datasource = value; }
        }

        /// <summary>
        /// Gets or sets the created date.
        /// </summary>
        /// <value>The created date.</value>
        public DateTime CreatedDate
        {
            get
            {
                return this.createdDate;
            }
            set
            {
                this.createdDate = value;
            }
        }

        /// <summary>
        /// Gets or sets the modified date.
        /// </summary>
        /// <value>The modified date.</value>
        public DateTime ModifiedDate
        {
            get
            {
                return this.modifiedDate;
            }
            set
            {
                this.modifiedDate = value;
            }
        }

   
   
        
        private string canvasName;

        /// <summary>
        /// Gets or sets CanvasName
        /// </summary>
        public string CanvasName
        {
            get { return canvasName; }
            set { canvasName = value; }
        }

        private string canvasDescription;
        /// <summary>
        /// Gets or Sets Canvas Description
        /// </summary>
        public string CanvasDescription
        {
            get { return canvasDescription; }
            set { canvasDescription = value; }
        }

    
        private XElement xmlData;

        /// <summary>
        /// Gets or sets XML Data
        /// </summary>
        public XElement XmlData
        {
            get { return xmlData; }
            set { xmlData = value; }
        }


        /// <summary>
        /// Gets or sets User ID
        /// </summary>
        public int UserId { get; set; }


        public int CanvasId { get; set; }

        public bool IsNewCanvas { get; set; }

        public string Status { get; set; }

        public bool IsShared { get; set; }

    }
}