﻿/*  ----------------------------------------------------------------------------
 *  Emergint Technologies, Inc.
 *  ----------------------------------------------------------------------------
 *  Epi Info™ - Web Analysis & Visualization
 *  ----------------------------------------------------------------------------
 *  File:       AdminDatasourcesDomainService.cs
 *  Namespace:  Ewav.Web.Services.AdminDatasourcesDomainService    
 *
 *  Author(s):  Daniel Shorter, Mohammad Usman, Ninad Date, Sachin Agnihotri 
 *  Created:    26/08/2013    
 *  Summary:	no summary     
 *  ----------------------------------------------------------------------------
 */
namespace Ewav.Web.Services.AdminDatasourcesDomainService
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Linq;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;
using Ewav.DTO;
    using Ewav.BAL;


    // TODO: Create methods containing your application logic.
    [EnableClientAccess()]
    public class AdminDatasourcesDomainService : DomainService
    {
        EntityManager em = new EntityManager();

        /// <summary>
        /// Tests the DB connection.
        /// </summary>
        /// <param name="connInfo">The conn info.</param>
        /// <returns></returns>
        public bool TestDBConnection(Connection connInfo) 
        {
            return em.TestDBConnection(connInfo);
        }

        /// <summary>
        /// Tests the data.
        /// </summary>
        /// <param name="connectionInfo">The connection info.</param>
        /// <returns></returns>
        public bool TestData(Connection connectionInfo)
        {
            return em.TestData(connectionInfo);
        }

        /// <summary>
        /// Adds the datasource.
        /// </summary>
        /// <param name="ds">The ds.</param>
        /// <returns></returns>
        public bool AddDatasource(DatasourceDto ds) 
        {
            return em.AddDatasouce(ds);
        }

        /// <summary>
        /// Updates the datasource.
        /// </summary>
        /// <param name="dto">The dto.</param>
        /// <returns></returns>
        public bool UpdateDatasource(DatasourceDto dto)
        {
            return em.UpdateDatasource(dto);
        }

        /// <summary>
        /// Removes the datasource.
        /// </summary>
        /// <param name="dsId">The ds id.</param>
        /// <returns></returns>
        public bool RemoveDatasource(int dsId) 
        {
            return em.RemoveDatasource(dsId);
        }

        /// <summary>
        /// Reads the datasource.
        /// </summary>
        /// <returns></returns>
        public List<DatasourceDto> ReadDatasource(int orgId) 
        {
            return em.ReadDatasource(orgId);
        }


        /// <summary>
        /// Reads the associated users.
        /// </summary>
        /// <param name="p">The p.</param>
        /// <returns></returns>
        public List<UserDTO> ReadAssociatedUsers(int dsId, int orgId) 
        {
            return em.ReadAssociatedUsers(dsId, orgId);
        }

    }
}