﻿/*  ----------------------------------------------------------------------------
 *  Emergint Technologies, Inc.
 *  ----------------------------------------------------------------------------
 *  Epi Info™ - Web Analysis & Visualization
 *  ----------------------------------------------------------------------------
 *  File:       App.xaml.cs
 *  Namespace:  Ewav    
 *
 *  Author(s):  Daniel Shorter, Mohammad Usman, Ninad Date, Sachin Agnihotri 
 *  Created:    26/08/2013    
 *  Summary:	no summary     
 *  ----------------------------------------------------------------------------
 */
using System.Windows;
using System.Windows.Controls;
using Ewav.ViewModels;
using System;
using System.ServiceModel.DomainServices.Client.ApplicationServices;
using Ewav.Web.Services;

namespace Ewav
{
    public partial class App : Application
    {
        //ReadWebConfigDomainContext ctx = null;
        WebContext webCtx = null;
        public App()
        {
            this.Startup += this.Application_Startup;
            this.UnhandledException += this.Application_UnhandledException;

            InitializeComponent();


            //webCtx = new WebContext();

            //   this.ApplicationLifetimeObjects.Add(webCtx);
        }

        private void Application_Startup(object sender, StartupEventArgs e)
        {


            ApplicationViewModel.Instance.AuthenticationMode = e.InitParams["AuthenticationMode"].ToString();
            ApplicationViewModel.Instance.KeyForUserPasswordSalt = e.InitParams["KeyForUserPasswordSalt"].ToString();

            //  FullScreen support 
            DashboardMainPage dmp = new DashboardMainPage();
            
            this.RootVisual = dmp;

            dmp.FullScreenButton.Click += delegate(Object s,  RoutedEventArgs args)
            {
                this.Host.Content.IsFullScreen = !this.Host.Content.IsFullScreen;
            };



        }


        private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
        {
            // If the app is running outside of the debugger then report the exception using
            // a ChildWindow control.
            if (!System.Diagnostics.Debugger.IsAttached)
            {
                // NOTE: This will allow the application to continue running after an exception has been thrown
                // but not handled. 
                // For production applications this error handling should be replaced with something that will 
                // report the error to the website and stop the application.
                e.Handled = true;
                ChildWindow errorWin = new ErrorWindow(e.ExceptionObject);
                errorWin.Show();
            }
        }

        //private void OnLoadUser_Completed(LoadUserOperation operation)
        //{



        //    if (ApplicationViewModel.Instance.AuthenticationMode.ToString().ToLower() == "windows")
        //    {
        //        Membership.MembershipManager mm = new Membership.MembershipManager();
        //        // Authenticate this user aganist the EWAV database.  If authenticated,  load the user 
        //        mm.AuthenticateAndLoadUser(WebContext.Current.Authentication.User.Identity.Name.Split('\\')[1].ToString());


        //    }

        //}


    }
}