﻿/*  ----------------------------------------------------------------------------
 *  Emergint Technologies, Inc.
 *  ----------------------------------------------------------------------------
 *  Epi Info™ - Web Analysis & Visualization
 *  ----------------------------------------------------------------------------
 *  File:       ShareDash.xaml.cs
 *  Namespace:  Ewav    
 *
 *  Author(s):  Daniel Shorter, Mohammad Usman, Ninad Date, Sachin Agnihotri 
 *  Created:    26/08/2013    
 *  Summary:	no summary     
 *  ----------------------------------------------------------------------------
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Ewav.ViewModels;
using Ewav.Web.Services;
using Ewav.ExtensionMethods;
using Ewav.Client.Application;

namespace Ewav
{
    public partial class ShareDash : ChildWindow
    {
        ApplicationViewModel applicationViewModel;
        //List<string> userFirstNames, userLastNames;
        List<UserListInfo> userList = null;
        public ShareDash()
        {
            InitializeComponent();
            applicationViewModel = ApplicationViewModel.Instance;
            applicationViewModel.ShareCanvasCompletedEvent += new ShareCanvasCompletedEventHandler(applicationViewModel_ShareCanvasCompletedEvent);
            //userFirstNames = new List<string>();
            //userLastNames = new List<string>();
            tbTitle.Text = applicationViewModel.SelectedCanvasName;
            tbDataSource.Text = applicationViewModel.SelectedCanvasName;
            ReadAllUsersForMyOrg();
        }

        void applicationViewModel_ShareCanvasCompletedEvent(object o)
        {
            spMsg.Visibility = System.Windows.Visibility.Collapsed;
            spShare.Visibility = System.Windows.Visibility.Collapsed;
            spMsg_Success.Visibility = System.Windows.Visibility.Visible;
            applicationViewModel.IsCurrentCanvasShared = true;
        }

        private void ReadAllUsersForMyOrg()
        {
            UpdateUserList(false);
        }

        //private void MakeUserNamesList(DatatableBag dtb)
        //{
        //    userList = new List<UserListInfo>();
        //    for (int i = 0; i < dtb.RecordList.Count; i++)
        //    {
        //        if (dtb.GetValueAtRow("UserID", dtb.RecordList[i]) != applicationViewModel.LoggedInUser.UserDto.UserID)
        //        {


        //            userList.Add(new UserListInfo
        //                (false,
        //                dtb.GetValueAtRow("FirstName", dtb.RecordList[i]),
        //                dtb.GetValueAtRow("LastName", dtb.RecordList[i]),
        //                Convert.ToInt32(dtb.GetValueAtRow("UserID", dtb.RecordList[i]))
        //                ));
        //        }
        //    }
        //}

        private void BindGrid()
        {
            dgUsers.ItemsSource = null;
            dgUsers.ItemsSource = new UserListCollection(userList);
        }


        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            UserListCollection userList = (UserListCollection)dgUsers.ItemsSource;

            var filteredList = from user in userList
                               where user.IsSelected == true
                               select new { FirstName = user.FirstName, LastName = user.LastName, UserID = user.UserId };
            List<int> userIds = new List<int>();

            foreach (var item in filteredList)
            {
                userIds.Add(item.UserID);
            }
            if (applicationViewModel.CurrentCanvasId > 0)
            {
                applicationViewModel.ShareCanvas(applicationViewModel.CurrentCanvasId, userIds);
            }
            else
            {
                MessageBox.Show("Cannot share unsaved canvas.");
            }

            //this.DialogResult = true;
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }

        private void HyperlinkButton_Click(object sender, RoutedEventArgs e)
        {
            UpdateUserList(true);
        }

        private void UpdateUserList(bool AllSelected)
        {
            DatatableBag dtb = applicationViewModel.AllUsersInMyOrg;
            userList = new List<UserListInfo>();
            for (int i = 0; i < dtb.RecordList.Count; i++)
            {
                if (dtb.GetValueAtRow("USERNAME", dtb.RecordList[i]) != applicationViewModel.LoggedInUser.UserDto.UserName)
                {


                    userList.Add(new UserListInfo
                        (AllSelected,
                        dtb.GetValueAtRow("FIRSTNAME", dtb.RecordList[i]),
                        dtb.GetValueAtRow("LASTNAME", dtb.RecordList[i]),
                        Convert.ToInt32(dtb.GetValueAtRow("USERID", dtb.RecordList[i]))
                        ));
                }
            }
            BindGrid();
        }

        private void btnBegin_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
        }

        private void HyperlinkButton_Click_1(object sender, RoutedEventArgs e)
        {
            UpdateUserList(false);
        }
    }

    //public class UserListInfo : INotifyPropertyChanged
    //{
    //    public event PropertyChangedEventHandler PropertyChanged;

    //    private bool isSelected;

    //    public bool IsSelected
    //    {
    //        get { return isSelected; }
    //        set
    //        {
    //            isSelected = value;
    //            OnPropertyChanged("IsSelected");
    //        }
    //    }

    //    private void OnPropertyChanged(string p)
    //    {
    //        PropertyChangedEventHandler handler = PropertyChanged;
    //        if (handler != null)
    //        {
    //            handler(this, new PropertyChangedEventArgs(p));
    //        }
    //    }

    //    private string firstName;

    //    public string FirstName
    //    {
    //        get { return firstName; }
    //        set
    //        {
    //            firstName = value;
    //            OnPropertyChanged("FirstName");
    //        }
    //    }

    //    private string lastName;

    //    public string LastName
    //    {
    //        get { return lastName; }
    //        set
    //        {
    //            lastName = value;
    //            OnPropertyChanged("LastName");
    //        }
    //    }

    //    private int userId;
    //    public int UserId
    //    {
    //        get { return userId; }
    //        set { userId = value; OnPropertyChanged("UserID"); }
    //    }

    //    public UserListInfo(bool isSelected, string firstName, string lastName, int userId)
    //    {
    //        this.IsSelected = isSelected;
    //        this.FirstName = firstName;
    //        this.LastName = lastName;
    //        this.UserId = userId;
    //    }

    //}

    //public class UserListCollection : ObservableCollection<UserListInfo>
    //{
    //    public UserListCollection(List<UserListInfo> userList)
    //        : base()
    //    {
    //        for (int i = 0; i < userList.Count; i++)
    //        {
    //            Add(new UserListInfo(userList[i].IsSelected,
    //                                userList[i].FirstName,
    //                                userList[i].LastName,
    //                                userList[i].UserId));
    //        }
    //    }
    //}
}