﻿/*  ----------------------------------------------------------------------------
 *  Emergint Technologies, Inc.
 *  ----------------------------------------------------------------------------
 *  Epi Info™ - Web Analysis & Visualization
 *  ----------------------------------------------------------------------------
 *  File:       DataFilterControl.xaml.cs
 *  Namespace:  Ewav    
 *
 *  Author(s):  Daniel Shorter, Mohammad Usman, Ninad Date, Sachin Agnihotri 
 *  Created:    26/08/2013    
 *  Summary:	no summary     
 *  ----------------------------------------------------------------------------
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;

using System.Windows.Media.Animation;
using Ewav.BAL;
using Ewav.ViewModels;
using Ewav.Web.Services;

using System.Windows.Input;

namespace Ewav
{
    /// <summary>
    /// JoinType enumeration.
    /// </summary>
    public enum JoinType
    {
        AND = 0,
        OR
    }

    /// <summary>
    /// Interaction logic for DataFilterControl.xaml
    /// </summary>
    public partial class DataFilterControl : UserControl
    {
        public ApplicationViewModel applicationViewModel = ApplicationViewModel.Instance;
        List<EwavColumn> colsList;
        List<string> extractedList, operatorsList, configList;
        int globalPointer = 0, globalRemovedPointer = 0;
        private bool dataFilterSlideCheck = false;
        List<int> rowRemoved = new List<int>();
        private Storyboard SlideIn = new Storyboard();
        private Storyboard SlideOut = new Storyboard();
        List<EwavColumn> SourceColumns;
        bool unsavedIndicator = false;
        //EwavFilterControl filterControl;
        /// <summary>
        /// Default Constructor
        /// </summary>
        public DataFilterControl()
        {
            InitializeComponent();
            SlideOut.Children.Add(CreateSlidingAnim("Slider", 644));
            LayoutRoot.Resources.Add("SlideOut", SlideOut);

            SlideIn.Children.Add(CreateSlidingAnim("Slider", 0));
            LayoutRoot.Resources.Add("SlideIn", SlideIn);

            Slider.MouseEnter += new MouseEventHandler(Slider_MouseEnter);
            Slider.MouseLeave += new MouseEventHandler(Slider_MouseLeave);
            //btnClear.IsEnabled = false;

            this.Loaded += new RoutedEventHandler(DataFilterControl_Loaded);

            //applicationViewModel.UnloadedEvent += new Client.Application.UnloadedEventHandler(applicationViewModel_UnloadedEvent);

            //this.Unloaded += new RoutedEventHandler(DataFilterControl_Unloaded);

            DashboardMainPage.DragCanvasRightMouseDownEvent -= new Client.Application.DragCanvasRightMouseDownEventHandler(DashboardMainPage_DragCanvasRightMouseDownEvent);
            applicationViewModel.FilterStringUpdatedEvent -= new Client.Application.FilterStringUpdatedEventHandler(applicationViewModel_FilterStringUpdatedEvent);

            applicationViewModel.ApplyDataFilterEvent -= new Client.Application.ApplyFilterEventHandler(applicationViewModel_ApplyDataFilterEvent);
            applicationViewModel.DefinedVariableAddedEvent -= new Client.Application.DefinedVariableAddedEventHandler(applicationViewModel_DefinedVariableAddedEvent);
            applicationViewModel.DefinedVariableInUseDeletedEvent -= new Client.Application.DefinedVariableInUseDeletedEventHandler(applicationViewModel_DefinedVariableInUseDeletedEvent);
            applicationViewModel.DefinedVariableNotInUseDeletedEvent -= new Client.Application.DefinedVariableNotInUseDeletedEventHandler(applicationViewModel_DefinedVariableNotInUseDeletedEvent);
            applicationViewModel.UpdateDataFilterCount -= new Client.Application.UpdateDataFilterCountEventHandler(applicationViewModel_UpdateDataFilterCount);

            DashboardMainPage.DragCanvasRightMouseDownEvent += new Client.Application.DragCanvasRightMouseDownEventHandler(DashboardMainPage_DragCanvasRightMouseDownEvent);
            applicationViewModel.FilterStringUpdatedEvent += new Client.Application.FilterStringUpdatedEventHandler(applicationViewModel_FilterStringUpdatedEvent);

            applicationViewModel.ApplyDataFilterEvent += new Client.Application.ApplyFilterEventHandler(applicationViewModel_ApplyDataFilterEvent);
            applicationViewModel.DefinedVariableAddedEvent += new Client.Application.DefinedVariableAddedEventHandler(applicationViewModel_DefinedVariableAddedEvent);
            applicationViewModel.DefinedVariableInUseDeletedEvent += new Client.Application.DefinedVariableInUseDeletedEventHandler(applicationViewModel_DefinedVariableInUseDeletedEvent);
            applicationViewModel.DefinedVariableNotInUseDeletedEvent += new Client.Application.DefinedVariableNotInUseDeletedEventHandler(applicationViewModel_DefinedVariableNotInUseDeletedEvent);
            applicationViewModel.ClearDataFiltersEvent += new Client.Application.ClearDataFiltersEventHandler(applicationViewModel_ClearDataFiltersEvent);
            applicationViewModel.UpdateDataFilterCount += new Client.Application.UpdateDataFilterCountEventHandler(applicationViewModel_UpdateDataFilterCount);

            applicationViewModel.ColumnsLoadedEvent += new Client.Application.ColumnsLoadedEventEventHandler(applicationViewModel_ColumnsLoadedEvent);
        }

        void applicationViewModel_ColumnsLoadedEvent(object o, Client.Application.ColumnsLoadedEventEventArgs e)
        {


            FilterControl.FilterType = FilterControlType.DataFilter;
            FilterControl.InitializeDataFilter();

        }



        void applicationViewModel_UpdateDataFilterCount(object o)
        {
            filterCount.Text = string.Format("Data Filter ({0})", applicationViewModel.EwavDatafilters.Count);
            VerticalHeading.Text = string.Format("Data Filter ({0})", applicationViewModel.EwavDatafilters.Count);
        }

        void applicationViewModel_ClearDataFiltersEvent(object o)
        {
            Clear();
        }

        //void applicationViewModel_UnloadedEvent(object o)
        //{
        //    DashboardMainPage.DragCanvasRightMouseDownEvent -= new Client.Application.DragCanvasRightMouseDownEventHandler(DashboardMainPage_DragCanvasRightMouseDownEvent);
        //    applicationViewModel.FilterStringUpdatedEvent -= new Client.Application.FilterStringUpdatedEventHandler(applicationViewModel_FilterStringUpdatedEvent);

        //    applicationViewModel.ApplyDataFilterEvent -= new Client.Application.ApplyFilterEventHandler(applicationViewModel_ApplyDataFilterEvent);
        //    applicationViewModel.DefinedVariableAddedEvent -= new Client.Application.DefinedVariableAddedEventHandler(applicationViewModel_DefinedVariableAddedEvent);
        //    applicationViewModel.DefinedVariableInUseDeletedEvent -= new Client.Application.DefinedVariableInUseDeletedEventHandler(applicationViewModel_DefinedVariableInUseDeletedEvent);
        //    applicationViewModel.DefinedVariableNotInUseDeletedEvent -= new Client.Application.DefinedVariableNotInUseDeletedEventHandler(applicationViewModel_DefinedVariableNotInUseDeletedEvent);
        //}

        //void DataFilterControl_Unloaded(object sender, RoutedEventArgs e)
        //{
        //    DashboardMainPage.DragCanvasRightMouseDownEvent -= new Client.Application.DragCanvasRightMouseDownEventHandler(DashboardMainPage_DragCanvasRightMouseDownEvent);
        //    applicationViewModel.FilterStringUpdatedEvent -= new Client.Application.FilterStringUpdatedEventHandler(applicationViewModel_FilterStringUpdatedEvent);

        //    applicationViewModel.ApplyDataFilterEvent -= new Client.Application.ApplyFilterEventHandler(applicationViewModel_ApplyDataFilterEvent);
        //    applicationViewModel.DefinedVariableAddedEvent -= new Client.Application.DefinedVariableAddedEventHandler(applicationViewModel_DefinedVariableAddedEvent);
        //    applicationViewModel.DefinedVariableInUseDeletedEvent -= new Client.Application.DefinedVariableInUseDeletedEventHandler(applicationViewModel_DefinedVariableInUseDeletedEvent);
        //    applicationViewModel.DefinedVariableNotInUseDeletedEvent -= new Client.Application.DefinedVariableNotInUseDeletedEventHandler(applicationViewModel_DefinedVariableNotInUseDeletedEvent);
        //}


        void DataFilterControl_Loaded(object sender, RoutedEventArgs e)
        {

            if (this.applicationViewModel.EwavSelectedDatasource.AllColumns != null)
            {
                //initializeDataFilter();
                //if (filterControl == null)
                //{
                //    filterControl = new EwavFilterControl();
                //    filterControl.FilterType = FilterControlType.DataFilter;
                //    filterControl.MainPanel = pnlContainer;
                //    filterControl.InitializeDataFilter();
                //}

                //FilterControl.FilterType = FilterControlType.DataFilter;
                //FilterControl.InitializeDataFilter();

            }
        }


        void applicationViewModel_DefinedVariableNotInUseDeletedEvent(object o)
        {
            RefreshDataFilter();
        }

        void applicationViewModel_DefinedVariableInUseDeletedEvent(object o)
        {
            //bool variableFound = false;
            //for (int i = 0; i <= globalPointer; i++)
            //{
            //    ComboBox cmb = ((ComboBox)FindControlInRow(i, "field"));
            //    if (cmb != null)
            //    {
            //        if (((EwavColumn)cmb.SelectedItem).Name == ((EwavColumn)o).Name)
            //        {
            //            pnlContainer.Children.Remove(FindStackPanel(i, "sp"));
            //            variableFound = true;
            //        }
            //    }
            //}
            //if (applicationViewModel.EwavDatafilters.Count > 0 && variableFound)
            //{
            //    RefreshDataFilter();
            //    globalRemovedPointer++;
            //    DoDataFilter();
            //    CreateAndAddRow();
            //}
            if (ApplicationViewModel.Instance.IsDefVarInUseByDF)// TBD When NO DF then applyDFEVent gets raised for gadgets. shouldnt be.
            {
                FilterControl.UserDefinedVarInUse(o);
            }
            else
            {
                RefreshDataFilter();
            }



        }

        void applicationViewModel_DefinedVariableAddedEvent(object o)
        {
            RefreshDataFilter();
        }
        bool loadingCombos = false;

        public void RefreshDataFilter()
        {
            //FillSelectionComboboxes();


            ////((ComboBox)FindControlInRow(rowNumber, "field"))


            //for (int i = 0; i <= this.globalPointer; i++)
            //{
            //    if (FindControlInRow(i, "field") != null)
            //    {
            //        string selectedValue = ((EwavColumn)((ComboBox)FindControlInRow(i, "field")).SelectedItem).Name;
            //        loadingCombos = true;
            //        ComboBox cmb = ((ComboBox)FindControlInRow(i, "field"));
            //        cmb.ItemsSource = null;
            //        cmb.ItemsSource = colsList; // extractedList; 
            //        SetSelectedIndex(cmb, selectedValue);
            //        loadingCombos = false;
            //    }

            //}
            FilterControl.RefreshDataFilter();

        }

        //private void SetSelectedIndex(ComboBox cmb, string selectedValue)
        //{

        //    for (int i = 0; i < cmb.Items.Count; i++)
        //    {
        //        if (((EwavColumn)cmb.Items[i]).Name == selectedValue)
        //        {
        //            cmb.SelectedIndex = i;
        //            break;
        //        }
        //    }

        //}
        void DashboardMainPage_DragCanvasRightMouseDownEvent(DashboardMainPage d)
        {


            SlideIn.Begin();
            rotatearrow1.Begin();
            dataFilterSlideCheck = false;

        }
        ///// <summary>
        ///// Method that creates and adds the row to the stack panel
        ///// </summary>
        //public void CreateAndAddRow()
        //{
        //    globalPointer++;
        //    //btnClear.IsEnabled = true;

        //    StackPanel sp = new StackPanel();
        //    sp.Orientation = Orientation.Horizontal;
        //    sp.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //    sp.Name = string.Format("sp,{0}", globalPointer);

        //    //TextBlock tblk = new TextBlock();
        //    //tblk.Text = "The Value of  ";
        //    //tblk.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //    //tblk.Name = "textblock" + globalPointer;
        //    //tblk.Width = 70;
        //    //tblk.Margin = new Thickness(4, 2, 2, 2);
        //    //sp.Children.Add(tblk);

        //    Image img = new Image();
        //    img.Name = string.Format("img{0}", globalPointer);
        //    img.Source = new BitmapImage(new Uri("../../Images/error.png", UriKind.Relative));
        //    img.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //    img.Margin = new Thickness(4, 2, 2, 2);
        //    img.Width = 16;
        //    img.Visibility = System.Windows.Visibility.Collapsed;
        //    sp.Children.Add(img);

        //    ComboBox cmb = new ComboBox();
        //    cmb.ItemsSource = colsList;
        //    cmb.SelectedValuePath = "Index";
        //    cmb.DisplayMemberPath = "Name";
        //    cmb.Name = string.Format("field,{0}", globalPointer);
        //    cmb.Width = 150;
        //    cmb.Margin = new Thickness(4, 2, 2, 2);
        //    cmb.SelectedIndex = 0;
        //    cmb.SelectionChanged += new SelectionChangedEventHandler(cmb_SelectionChanged);
        //    sp.Children.Add(cmb);

        //    ComboBox cmb1 = new ComboBox();
        //    cmb1.ItemsSource = operatorsList;
        //    cmb1.Name = string.Format("operator,{0}", globalPointer);
        //    cmb1.SelectionChanged += new SelectionChangedEventHandler(cmbOp_SelectionChanged);
        //    cmb1.Width = 120;
        //    cmb1.Margin = new Thickness(4, 2, 2, 2);
        //    sp.Children.Add(cmb1);

        //    StackPanel subSp = new StackPanel();
        //    subSp.Orientation = Orientation.Horizontal;
        //    subSp.VerticalAlignment = System.Windows.VerticalAlignment.Center;

        //    TextBox tb = new TextBox();
        //    tb.Name = string.Format("tb,{0}", globalPointer);
        //    tb.Width = 200;
        //    tb.Margin = new Thickness(4, 2, 2, 2);
        //    tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //    subSp.Name = string.Format("subSp,{0}", globalPointer);
        //    subSp.Children.Add(tb);
        //    sp.Children.Add(subSp);

        //    Button but = new Button();
        //    but.Click += new RoutedEventHandler(btnAdd_Click);
        //    but.Content = "ADD";
        //    but.Style = Application.Current.Resources["Add"] as Style;
        //    but.Cursor = Cursors.Hand;
        //    but.Name = string.Format("but,{0}", globalPointer);
        //    //but.Width = 70;
        //    but.Margin = new Thickness(4, 2, 2, 2);
        //    sp.Children.Add(but);
        //    pnlContainer.Children.Add(sp);
        //    filterCount.Text = string.Format("Data Filter ({0})", globalPointer - globalRemovedPointer);
        //}

        ///// <summary>
        ///// Method that creates dataFilter
        ///// </summary>
        ///// <returns></returns>
        //public List<EwavDataFilterCondition> CreateDataFilters()
        //{
        //    List<EwavDataFilterCondition> filtercondList = new List<EwavDataFilterCondition>();
        //    int childCount = pnlContainer.Children.Count;

        //    for (int i = 0; i < childCount; i++)
        //    {
        //        UIElementCollection listOfCtrl = ((StackPanel)pnlContainer.Children[i]).Children;

        //        ColumnDataType dataType = LookUpDataType(((ComboBox)listOfCtrl[1]).SelectedItem);

        //        if (((EwavColumn)((ComboBox)listOfCtrl[1]).SelectedItem).IsUserDefined)
        //        {
        //            ((EwavColumn)((ComboBox)listOfCtrl[1]).SelectedItem).IsInUse = true;
        //        }
        //        string operatorSelected = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString();
        //        switch (dataType)
        //        {
        //            case ColumnDataType.Text:

        //                filtercondList.Add(
        //                    new EwavDataFilterCondition()
        //                    {
        //                        FieldName = ((EwavColumn)((ComboBox)listOfCtrl[1]).SelectedItem).Name.ToString().ToMyString(),
        //                        FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                        FriendlyValue = ((TextBox)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                        JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                    });

        //                break;
        //            case ColumnDataType.Numeric:
        //                if (SharedStrings.FRIENDLY_OPERATOR_BETWEEN == operatorSelected)
        //                {
        //                    filtercondList.Add(
        //                        new EwavDataFilterCondition()
        //                        {
        //                            FieldName = ((EwavColumn)((ComboBox)listOfCtrl[1]).SelectedItem).Name.ToMyString(),
        //                            FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                            FriendLowValue = ((TextBox)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                            FriendHighValue = ((TextBox)((StackPanel)listOfCtrl[3]).Children[2]).Text.ToString().ToMyString(),
        //                            JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                        });
        //                }
        //                else
        //                {
        //                    filtercondList.Add(
        //                        new EwavDataFilterCondition()
        //                        {
        //                            FieldName = ((EwavColumn)((ComboBox)listOfCtrl[1]).SelectedItem).Name.ToMyString(),
        //                            FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                            FriendlyValue = ((TextBox)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                            JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                        });
        //                }
        //                break;
        //            case ColumnDataType.Boolean:
        //                MyString fValue;
        //                if (((ComboBox)((StackPanel)listOfCtrl[3]).Children[0]).IsEnabled)
        //                {
        //                    if (((ComboBox)((StackPanel)listOfCtrl[3]).Children[0]).SelectedItem.ToString().ToUpper() == "MISSING")
        //                    {
        //                        fValue = "missing".ToMyString();
        //                    }
        //                    else
        //                    {
        //                        fValue = ((ComboBox)((StackPanel)listOfCtrl[3]).Children[0]).SelectedItem.ToString().ToMyString();
        //                    }
        //                }
        //                else
        //                {
        //                    fValue = new MyString();
        //                }
        //                filtercondList.Add(
        //                    new EwavDataFilterCondition()
        //                    {
        //                        FieldName = ((EwavColumn)((ComboBox)listOfCtrl[1]).SelectedItem).Name.ToMyString(),
        //                        FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                        FriendlyValue = fValue,
        //                        JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                    });
        //                break;
        //            case ColumnDataType.DateTime:
        //                if (SharedStrings.FRIENDLY_OPERATOR_BETWEEN == operatorSelected)
        //                {
        //                    filtercondList.Add(
        //                        new EwavDataFilterCondition()
        //                        {
        //                            FieldName = ((EwavColumn)((ComboBox)listOfCtrl[1]).SelectedItem).Name.ToMyString(),
        //                            FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                            FriendLowValue = ((DatePicker)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                            FriendHighValue = ((DatePicker)((StackPanel)listOfCtrl[3]).Children[2]).Text.ToString().ToMyString(),
        //                            JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                        });
        //                }
        //                else
        //                {
        //                    filtercondList.Add(
        //                        new EwavDataFilterCondition()
        //                        {
        //                            FieldName = ((EwavColumn)((ComboBox)listOfCtrl[1]).SelectedItem).Name.ToMyString(),
        //                            FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                            FriendlyValue = ((DatePicker)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                            JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                        });
        //                }
        //                break;
        //            case ColumnDataType.UserDefined:
        //                break;
        //            default:
        //                break;
        //        }
        //    }

        //    return filtercondList;
        //}

        ///// <summary>
        ///// Fills in the Field Names combo box
        ///// </summary>
        //public void FillSelectionComboboxes()
        //{
        //    SourceColumns = this.applicationViewModel.EwavSelectedDatasource.AllColumns;
        //    extractedList = new List<string>();
        //    operatorsList = new List<string>();
        //    configList = new List<string>();

        //    //List<ColumnDataType> columnDataType = new List<ColumnDataType>();
        //    //columnDataType.Add(ColumnDataType.Boolean);
        //    //columnDataType.Add(ColumnDataType.Numeric);
        //    //columnDataType.Add(ColumnDataType.DateTime);
        //    //columnDataType.Add(ColumnDataType.Text);

        //    IEnumerable<EwavColumn> CBXFieldCols = from cols in SourceColumns
        //                                           //where cols.IsUserDefined == false
        //                                           orderby cols.Name
        //                                           select cols;

        //    colsList = CBXFieldCols.ToList();

        //    colsList.Insert(0, new EwavColumn() { Name = " ", Index = -1 });

        //    for (int i = 0; i < colsList.Count; i++)
        //    {
        //        extractedList.Add(colsList[i].Name);
        //    }
        //}

        ///// <summary>
        ///// Validates the controls.
        ///// </summary>
        ///// <param name="stackPanel"></param>
        ///// <returns></returns>
        //public Boolean ValidateControl()
        //{
        //    for (int j = 0; j < pnlContainer.Children.Count; j++)
        //    {
        //        StackPanel child = (StackPanel)pnlContainer.Children[j];

        //        for (int k = 0; k < child.Children.Count; k++)
        //        {
        //            if (child.Children[k] is ComboBox && ((ComboBox)child.Children[k]).SelectedItem.ToString().Trim() == "")
        //            {
        //                var myElement = ((FrameworkElement)this.LayoutRoot).FindName(string.Format("img{0}", j));
        //                ((Image)myElement).Visibility = System.Windows.Visibility.Visible;
        //                return false;
        //            }
        //            else if (child.Children[k] is StackPanel)
        //            {
        //                return ValidateStackPanel((StackPanel)child.Children[k]);
        //            }
        //        }
        //    }
        //    return true;
        //}

        //public bool ValidateStackPanel(StackPanel sp)
        //{
        //    StackPanel stackPanel = sp;
        //    string spName = sp.Name;
        //    int j = Convert.ToInt32(spName.Substring(spName.IndexOf(",") + 1, spName.Length - spName.IndexOf(",") - 1));

        //    String s = string.Empty;

        //    for (int i = 0; i < stackPanel.Children.Count; i++)
        //    {
        //        if (stackPanel.Children[0] is TextBox && ((TextBox)stackPanel.Children[0]).Text == "")
        //        {
        //            s += "No Data Entered in the Text Box\n";
        //        }
        //        else if (stackPanel.Children[0] is ComboBox && ((ComboBox)stackPanel.Children[0]).SelectedIndex < 0)
        //        {
        //            s += "No Selection has been made for combo Box\n";
        //        }
        //        else if (stackPanel.Children[0] is DatePicker && ((DatePicker)stackPanel.Children[0]).Text == "")
        //        {
        //            s += "No Date selected.\n";
        //        }
        //    }
        //    if (s.Length > 0)
        //    {
        //        var myElement = ((FrameworkElement)this.LayoutRoot).FindName(string.Format("img{0}", j));
        //        ((Image)myElement).Visibility = System.Windows.Visibility.Visible;
        //        return false;
        //    }
        //    else
        //    {
        //        var myElement = ((FrameworkElement)this.LayoutRoot).FindName(string.Format("img{0}", j));
        //        ((Image)myElement).Visibility = System.Windows.Visibility.Collapsed;
        //    }
        //    return true;
        //}

        void applicationViewModel_ApplyDataFilterEvent(object o)
        {
            filterCount.Text = string.Format("Data Filter ({0})", applicationViewModel.EwavDatafilters.Count());
        }

        void applicationViewModel_FilterStringUpdatedEvent(object o)
        {
            txtAdvancedFilter.Text = applicationViewModel.FilterString;
            //txtAdvancedFilter.Text = applicationViewModel.AdvancedDataFilterString;
        }

        /// <summary>
        /// Add button click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //void btnAdd_Click(object sender, RoutedEventArgs e)
        //{
        //    string buttonName = ((Button)sender).Name;
        //    int rowNumber = Convert.ToInt32(buttonName.Substring(buttonName.IndexOf(",") + 1, buttonName.Length - buttonName.IndexOf(",") - 1));
        //    ((StackPanel)pnlContainer.Children[rowNumber - globalRemovedPointer]).Children.Remove(FindControlInRow(rowNumber, "but"));

        //    ComboBox cmbJoinType = new ComboBox();
        //    cmbJoinType.Name = string.Format("cmbJoinType, {0}", globalPointer);

        //    cmbJoinType.Items.Add(JoinType.AND);
        //    cmbJoinType.Items.Add(JoinType.OR);
        //    cmbJoinType.Width = 58;
        //    cmbJoinType.Margin = new Thickness(4, 2, 2, 2);
        //    cmbJoinType.SelectedIndex = 0;
        //    cmbJoinType.SelectionChanged += new SelectionChangedEventHandler(cmbJoinType_SelectionChanged);
        //    ((StackPanel)pnlContainer.Children[rowNumber - globalRemovedPointer]).Children.Add(cmbJoinType);

        //    Button butRemove = new Button();
        //    butRemove.Name = string.Format("btnRemove,{0}", globalPointer);
        //    butRemove.Content = "X";
        //    butRemove.HorizontalAlignment = System.Windows.HorizontalAlignment.Right;
        //    //butRemove.Width = 14;
        //    //butRemove.Height = 14;
        //    butRemove.Click += new RoutedEventHandler(butRemove_Click);
        //    butRemove.Style = Application.Current.Resources["Remove"] as Style;
        //    butRemove.HorizontalAlignment = System.Windows.HorizontalAlignment.Right;
        //    butRemove.Cursor = Cursors.Hand;
        //    //butRemove.Margin = new Thickness(0, 5, 47, -2);
        //    butRemove.Margin = new Thickness(4, 2, 2, 2);

        //    ((StackPanel)pnlContainer.Children[rowNumber - globalRemovedPointer]).Children.Add(butRemove);

        //    filterCount.Text = string.Format("{0} * ", filterCount.Text);
        //    CreateAndAddRow();
        //    scroll_content.UpdateLayout();
        //    scroll_content.ScrollToVerticalOffset(double.MaxValue);
        //    btnApply.IsEnabled = true;
        //}

        private void btnAdvMode_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            // TODO: Add event handler implementation here.
            pnlAdvancedMode.Visibility = System.Windows.Visibility.Visible;
            pnlGuidedMode.Visibility = System.Windows.Visibility.Collapsed;
            btnAdvMode.Visibility = System.Windows.Visibility.Collapsed;
            btnGuidedMode.Visibility = System.Windows.Visibility.Visible;
            applicationViewModel.UseAdvancedFilter = true;
        }

        /// <summary>
        /// Button Apply Click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnApply_Click(object sender, RoutedEventArgs e)
        {
            DoDataFilter();
        }

        public void DoDataFilter()
        {
            //if (ValidateControl())
            //{
            if (applicationViewModel.UseAdvancedFilter)
            {
                applicationViewModel.AdvancedDataFilterString = txtAdvancedFilter.Text;
                VerticalHeading.Text = "Data Filters";
            }
            else
            {
                List<EwavDataFilterCondition> DFilters = FilterControl.CreateDataFilters();
                if (DFilters == null)
                {
                    return;
                }
                applicationViewModel.EwavDatafilters = DFilters;
            }

            SlideIn.Begin();
            rotatearrow1.Begin();
            dataFilterSlideCheck = false;
            //filterCount.Text = string.Format("Data Filter ({0})", pnlContainer.Children.Count);
            //VerticalHeading.Text = string.Format("Data Filter ({0})", pnlContainer.Children.Count);
            //}
        }

        /// <summary>
        /// Clear button event.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnClear_Click(object sender, RoutedEventArgs e)
        {
            Clear();
            //btnClear.IsEnabled = false;
            //btnApply.IsEnabled = false;
        }

        private void Clear()
        {
            //pnlContainer.Children.Clear();

            txtAdvancedFilter.Text = "";

            applicationViewModel.AdvancedDataFilterString = string.Empty;
            applicationViewModel.EwavDatafilters = new List<EwavDataFilterCondition>();
            FilterControl.GlobalPointer = 0;
            FilterControl.GlobalRemovedPointer = 0;
            //globalRemovedPointer = 0;
            // initializeDataFilter();
            filterCount.Text = "Data Filter (0)";
            VerticalHeading.Text = "Data Filter (0)";
            FilterControl.Clear();
            FilterControl.CreateFilterConditionRow();
            SlideIn.Begin();
            rotatearrow1.Begin();
            dataFilterSlideCheck = false;
        }

        public void CreateFromXml(List<EwavDataFilterCondition> Conditions, string advancedFilterString)
        {

            //EwavFilterControl filterControl = new EwavFilterControl();
            //filterControl.MainPanel = filterControl.ConstructStackPanelFromDataFilters(EwavDatafilters);

            //filterControl = new EwavFilterControl();
            if (advancedFilterString != null &&
                advancedFilterString.Length != 0)
            {
                pnlGuidedMode.Visibility = System.Windows.Visibility.Collapsed;
                pnlAdvancedMode.Visibility = System.Windows.Visibility.Visible;
                VerticalHeading.Text = "Data Filters";
                btnAdvMode.Visibility = System.Windows.Visibility.Collapsed;
                btnGuidedMode.Visibility = System.Windows.Visibility.Visible;
            }

            if (FilterControl == null)
            {
                FilterControl = (EwavFilter)Activator.CreateInstance(typeof(EwavFilter));
                FilterControl.FilterType = FilterControlType.DataFilter;
            }

            //filterControl.MainPanel = pnlContainer;
            FilterControl.ConstructStackPanelFromDataFilters(Conditions);

            //this.pnlContainer.Children.Clear();

            //for (int i = 0; i < filterControl.MainPanel.Children.Count; i++)
            //{
            //    StackPanel sp = (StackPanel)filterControl.MainPanel.Children[i];
            //    filterControl.MainPanel.Children.RemoveAt(i);
            //    pnl.Children.Add(sp);
            //    i--;
            //}

        }

        private void btnGuidedMode_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            // TODO: Add event handler implementation here.
            //txtAdvancedFilter.Text = "";
            pnlAdvancedMode.Visibility = System.Windows.Visibility.Collapsed;
            pnlGuidedMode.Visibility = System.Windows.Visibility.Visible;
            btnAdvMode.Visibility = System.Windows.Visibility.Visible;
            btnGuidedMode.Visibility = System.Windows.Visibility.Collapsed;
            applicationViewModel.UseAdvancedFilter = false;
        }

        private void btnNewCondition_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            SlideIn.Begin();
            rotatearrow1.Begin();
            dataFilterSlideCheck = false;
        }

        /// <summary>
        /// Remove Button event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //void butRemove_Click(object sender, RoutedEventArgs e)
        //{
        //    string buttonName = ((Button)sender).Name;
        //    int rowNumber = Convert.ToInt32(buttonName.Substring(buttonName.IndexOf(",") + 1, buttonName.Length - buttonName.IndexOf(",") - 1));
        //    pnlContainer.Children.Remove(FindStackPanel(rowNumber, "sp"));
        //    rowRemoved.Add(rowNumber);
        //    btnApply.IsEnabled = true;
        //    globalRemovedPointer++;
        //}

        ///// <summary>
        ///// Combo Box selection changed event
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void cmb_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    if (((ComboBox)sender).SelectedItem != null && ((ComboBox)sender).SelectedItem.ToString().Trim() != "" && !loadingCombos)
        //    {
        //        ColumnDataType dataType = LookUpDataType(((ComboBox)sender).SelectedItem);

        //        int rowNumber = Convert.ToInt32(((ComboBox)sender).Name.ToString().Split(new Char[] { ',' })[1]);

        //        FillOperatorValues(dataType);
        //        string controlName = "operator";
        //        Control elemnt = FindControlInRow(rowNumber, controlName);
        //        if (elemnt != null)
        //        {
        //            ((ComboBox)elemnt).ItemsSource = null;
        //            ((ComboBox)elemnt).ItemsSource = operatorsList;
        //        }
        //    }
        //    btnApply.IsEnabled = true;
        //}

        ///// <summary>
        ///// Bool Combo Box selection changed event
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void cmbBool_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    btnApply.IsEnabled = true;
        //}

        ///// <summary>
        ///// Join Combo Box selection changed event.
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void cmbJoinType_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    btnApply.IsEnabled = true;
        //}

        ///// <summary>
        ///// Operator Combo Box selection changed event. It adds specific controls to Sub Stack Panel according to dataType and operator Type.
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void cmbOp_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    btnApply.IsEnabled = true;
        //    if (((ComboBox)sender).SelectedItem != null)
        //    {
        //        int rowNumber = Convert.ToInt32(((ComboBox)sender).Name.ToString().Split(new Char[] { ',' })[1]);
        //        ColumnDataType dataType = LookUpDataType(((ComboBox)FindControlInRow(rowNumber, "field")).SelectedItem);

        //        StackPanel subSp = new StackPanel();
        //        subSp.Name = string.Format("subSp,{0}", globalPointer);
        //        string operatorSelected = ((ComboBox)sender).SelectedItem.ToString();

        //        StackPanel ctrlContainer = new StackPanel();
        //        ctrlContainer = FindStackPanel(rowNumber, "subSp", true);
        //        ctrlContainer.Children.Clear();
        //        ctrlContainer.Orientation = Orientation.Horizontal;

        //        switch (dataType)
        //        {
        //            case ColumnDataType.Text:

        //                TextBox tb = new TextBox();
        //                tb.Width = 200;
        //                tb.Margin = new Thickness(4, 2, 2, 2);
        //                tb.Name = string.Format("tb,{0}", rowNumber);
        //                tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //                tb.IsEnabled = SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING == operatorSelected ? false : true;
        //                ctrlContainer.Name = string.Format("subSp,{0}", rowNumber);
        //                ctrlContainer.Children.Add(tb);
        //                break;
        //            case ColumnDataType.Numeric:
        //                if (SharedStrings.FRIENDLY_OPERATOR_BETWEEN == operatorSelected)
        //                {
        //                    tb = new TextBox();
        //                    tb.Name = string.Format("tb{0}1", rowNumber);
        //                    tb.Width = 83;
        //                    tb.Margin = new Thickness(4, 2, 2, 2);
        //                    tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //                    ctrlContainer.Name = string.Format("subSp,{0}", rowNumber);
        //                    ctrlContainer.Children.Add(tb);
        //                    TextBlock tblk = new TextBlock();
        //                    tblk.Name = string.Format("between{0}", rowNumber);
        //                    //tblk.Width = 40;
        //                    tblk.Text = " and ";
        //                    tblk.Margin = new Thickness(0, 0, 1, 0);
        //                    tblk.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //                    ctrlContainer.Children.Add(tblk);
        //                    tb = new TextBox();
        //                    tb.Name = string.Format("tb{0}2", rowNumber);
        //                    tb.Width = 83;
        //                    tb.Margin = new Thickness(4, 2, 2, 2);
        //                    tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);


        //                    ctrlContainer.Children.Add(tb);
        //                }
        //                else
        //                {
        //                    tb = new TextBox();
        //                    tb.Width = 200;
        //                    tb.Margin = new Thickness(4, 2, 2, 2);
        //                    tb.Name = string.Format("tb,{0}", rowNumber);
        //                    tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //                    tb.IsEnabled = SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING == operatorSelected ? false : true;

        //                    tb.AddHandler(UIElement.KeyDownEvent, new KeyEventHandler(LayoutRoot_KeyDown), true);



        //                    ctrlContainer.Name = string.Format("subSp,{0}", rowNumber);
        //                    ctrlContainer.Children.Add(tb);
        //                }
        //                break;
        //            case ColumnDataType.Boolean:
        //                ComboBox cmbBool = new ComboBox();
        //                cmbBool.Name = string.Format("value{0}", rowNumber);
        //                cmbBool.Width = 200;
        //                cmbBool.Margin = new Thickness(4, 2, 2, 2);
        //                cmbBool.Items.Add("YES");
        //                cmbBool.Items.Add("NO");
        //                cmbBool.Items.Add("Missing");
        //                cmbBool.SelectionChanged += new SelectionChangedEventHandler(cmbBool_SelectionChanged);

        //                if (((ComboBox)sender).SelectedItem.ToString() == SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING)
        //                {
        //                    cmbBool.IsEnabled = false;
        //                }
        //                else
        //                {
        //                    cmbBool.IsEnabled = true;
        //                }
        //                ctrlContainer.Name = string.Format("subSp,{0}", rowNumber);
        //                ctrlContainer.Children.Where(p => p.GetType().ToString().Contains(string.Format("value{0}", rowNumber))).ToList().ForEach(q => ctrlContainer.Children.Remove(q));
        //                ctrlContainer.Children.Add(cmbBool);
        //                break;
        //            case ColumnDataType.DateTime:
        //                if (SharedStrings.FRIENDLY_OPERATOR_BETWEEN == operatorSelected)
        //                {
        //                    DatePicker dp = new DatePicker();
        //                    dp.Name = string.Format("dp{0}1", rowNumber);
        //                    //dp.Width = 95;
        //                    dp.Style = Application.Current.Resources["dpbetween"] as Style;
        //                    dp.Margin = new Thickness(4, 2, 14, 2);

        //                    dp.SelectedDateChanged += new EventHandler<SelectionChangedEventArgs>(dp_SelectedDateChanged);
        //                    ctrlContainer.Name = string.Format("subSp,{0}", rowNumber);
        //                    ctrlContainer.Children.Add(dp);
        //                    TextBlock tblk = new TextBlock();
        //                    tblk.Name = string.Format("between{0}", rowNumber);
        //                    //tblk.Width = 20;
        //                    tblk.Text = " - ";
        //                    tblk.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //                    ctrlContainer.Children.Add(tblk);
        //                    dp = new DatePicker();
        //                    dp.Name = string.Format("dp{0}2", rowNumber);
        //                    //dp.Width = 95;
        //                    dp.Style = Application.Current.Resources["dpbetween"] as Style;
        //                    dp.Margin = new Thickness(4, 2, 14, 2);
        //                    dp.SelectedDateChanged += new EventHandler<SelectionChangedEventArgs>(dp_SelectedDateChanged);

        //                    ctrlContainer.Children.Add(dp);
        //                }
        //                else
        //                {
        //                    DatePicker dp = new DatePicker();
        //                    dp.Name = string.Format("datep,{0}", rowNumber);
        //                    dp.Width = 190;
        //                    dp.Style = Application.Current.Resources["dpbetween"] as Style;
        //                    dp.Margin = new Thickness(4, 2, 12, 2);
        //                    dp.SelectedDateChanged += new EventHandler<SelectionChangedEventArgs>(dp_SelectedDateChanged);



        //                    dp.AddHandler(UIElement.KeyDownEvent, new KeyEventHandler(datepicker_KeyDown), true);
        //                    dp.GotFocus += new RoutedEventHandler(dp_GotFocus);


        //                    ctrlContainer.Name = string.Format("subSp,{0}", rowNumber);
        //                    ctrlContainer.Children.Add(dp);
        //                }
        //                break;
        //            case ColumnDataType.UserDefined:
        //                break;
        //            default:
        //                break;
        //        }
        //    }
        //}

        //void dp_GotFocus(object sender, RoutedEventArgs e)
        //{
        //    DatePicker dp = (DatePicker)sender;


        //}

        ///// <summary>
        ///// Handles the KeyDown event of the datepicker control.
        ///// </summary>
        ///// <param name="sender">The source of the event.</param>
        ///// <param name="e">The <see cref="System.Windows.Input.KeyEventArgs" /> instance containing the event data.</param>
        //private void datepicker_KeyDown(object sender, KeyEventArgs e)
        //{


        //    //// Determine whether the keystroke is a number from the top of the keyboard.
        //    //if (e.Key < Key.D0 || e.Key > Key.D9 || e.Key == Key.Divide)
        //    //{


        //    e.Handled = true;


        //    //}

        //}

        /// <summary>
        /// Handles the KeyDown event of the LayoutRoot control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Input.KeyEventArgs" /> instance containing the event data.</param>
        private void LayoutRoot_KeyDown(object sender, KeyEventArgs e)
        {




            int x;

            TextBox tb = (TextBox)sender;

            // Determine whether the keystroke is a number from the top of the keyboard.
            if (e.Key < Key.D0 || e.Key > Key.D9)
            {
                // Determine whether the keystroke is a number from the keypad.  
                if (e.Key < Key.NumPad0 || e.Key > Key.NumPad9)
                {



                    e.Handled = true;


                }

            }


        }


        private DoubleAnimation CreateSlidingAnim(string elementName, double toValue)
        {
            DoubleAnimation animation = new DoubleAnimation();
            animation.SetValue(Storyboard.TargetNameProperty, elementName);
            animation.SetValue(Storyboard.TargetPropertyProperty, new PropertyPath("(UIElement.RenderTransform).(TransformGroup.Children)[3].(TranslateTransform.X)"));
            animation.Duration = new Duration(TimeSpan.FromSeconds(0.5));
            animation.To = toValue;
            return animation;
        }

        /// <summary>
        /// Date picker date changed event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void dp_SelectedDateChanged(object sender, SelectionChangedEventArgs e)
        {
            btnApply.IsEnabled = true;
        }

        ///// <summary>
        ///// Fills in the 'operator' drop-down list based upon the type of field being used in the selection condition
        ///// </summary>
        ///// <param name="field">The field that the condition is based upon</param>
        //private void FillOperatorValues(ColumnDataType field)
        //{
        //    operatorsList.Clear();

        //    // Set operator drop-down values
        //    if (field == ColumnDataType.Numeric || field == ColumnDataType.DateTime)
        //    {
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_EQUAL_TO);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_BETWEEN);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_LESS_THAN);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_GREATER_THAN);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_LESS_THAN_OR_EQUAL);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_GREATER_THAN_OR_EQUAL);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING);
        //    }
        //    else if (field == ColumnDataType.Boolean)
        //    {
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_EQUAL_TO);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING);

        //        configList.Add("Yes");
        //        configList.Add("No");
        //        configList.Add("Missing");
        //    }
        //    else if (field == ColumnDataType.Text)
        //    {
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_EQUAL_TO);
        //        //operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_LIKE);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_BEGINSWITH);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_ENDSWITH);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_CONTAINS);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING);
        //    }
        //}

        ///// <summary>
        ///// Method that finds control in the row.
        ///// </summary>
        ///// <param name="rowNumber"></param>
        ///// <param name="controlName"></param>
        ///// <param name="deep"></param>
        ///// <returns></returns>
        //private Control FindControlInRow(int rowNumber, string controlName, bool deep = false)
        //{
        //    StackPanel sp;
        //    if (deep)
        //    {
        //        sp = FindStackPanel(rowNumber, "subSp", true);
        //    }
        //    else
        //    {
        //        sp = FindStackPanel(rowNumber, "sp");
        //    }
        //    if (sp != null)
        //    {
        //        int count = VisualTreeHelper.GetChildrenCount(sp);
        //        for (int i = 0; i < count; i++)
        //        {
        //            var child = VisualTreeHelper.GetChild(sp, i);
        //            if (child is Control)
        //            {
        //                if (((Control)child).Name.Contains(controlName))
        //                {
        //                    return (Control)child;
        //                }
        //            }
        //        }
        //    }

        //    return null;
        //}

        ///// <summary>
        ///// Method that finds StackPanel.
        ///// </summary>
        ///// <param name="rowNumber"></param>
        ///// <param name="controlName"></param>
        ///// <param name="deep"></param>
        ///// <returns></returns>
        //private StackPanel FindStackPanel(int rowNumber, string controlName, bool deep = false)
        //{
        //    StackPanel sp;
        //    if (deep)
        //    {
        //        sp = FindStackPanel(rowNumber, "sp");
        //    }
        //    else
        //    {
        //        sp = pnlContainer;
        //    }
        //    int count = VisualTreeHelper.GetChildrenCount(sp);
        //    for (int i = 0; i < count; i++)
        //    {
        //        var child = VisualTreeHelper.GetChild(sp, i);
        //        if (child is StackPanel)
        //        {
        //            if (((StackPanel)child).Name.Contains(string.Format("{0},{1}", controlName, rowNumber)))
        //            {
        //                return (StackPanel)child;
        //            }
        //        }
        //    }
        //    return null;
        //}

        ///// <summary>
        ///// method to initialize data filter control. And adds the first row in Stack Panel.
        ///// </summary>
        //void initializeDataFilter()
        //{
        //    FillSelectionComboboxes();
        //    if (FindStackPanel(0, "sp") == null)
        //    {
        //        StackPanel sp = new StackPanel();
        //        sp.Orientation = Orientation.Horizontal;
        //        sp.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //        sp.Name = string.Format("sp,{0}", globalPointer);

        //        //TextBlock tblk = new TextBlock();
        //        //tblk.Text = "The Value of  ";
        //        //tblk.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //        //tblk.Margin = new Thickness(4, 2, 2, 2);
        //        //tblk.Name = "textblock" + globalPointer;
        //        //tblk.Width = 70;
        //        //sp.Children.Add(tblk);
        //        Image img = new Image();
        //        img.Name = string.Format("img{0}", globalPointer);
        //        img.Source = new BitmapImage(new Uri("../../Images/error.png", UriKind.Relative));
        //        img.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //        img.Margin = new Thickness(4, 2, 2, 2);
        //        img.Width = 16;
        //        img.Visibility = System.Windows.Visibility.Collapsed;
        //        sp.Children.Add(img);

        //        ComboBox cmb = new ComboBox();
        //        cmb.ItemsSource = colsList;
        //        cmb.SelectedValuePath = "Index";
        //        cmb.DisplayMemberPath = "Name";
        //        //cmb.SetBinding(this,)
        //        cmb.Margin = new Thickness(4, 2, 2, 2);
        //        cmb.SelectedIndex = 0;
        //        cmb.Width = 150;
        //        cmb.SelectionChanged += new SelectionChangedEventHandler(cmb_SelectionChanged);
        //        cmb.Name = string.Format("field,{0}", globalPointer);
        //        sp.Children.Add(cmb);

        //        cmb = new ComboBox();
        //        cmb.ItemsSource = operatorsList;
        //        cmb.Margin = new Thickness(4, 2, 2, 2);
        //        cmb.Width = 120;
        //        cmb.Name = string.Format("operator,{0}", globalPointer);
        //        cmb.SelectionChanged += new SelectionChangedEventHandler(cmbOp_SelectionChanged);
        //        sp.Children.Add(cmb);

        //        StackPanel subSp = new StackPanel();

        //        TextBox tb = new TextBox();
        //        tb.Width = 200;
        //        tb.Margin = new Thickness(4, 2, 2, 2);
        //        tb.Name = string.Format("tb,{0}", globalPointer);
        //        tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //        ToolTipService.SetToolTip(tb, "Please enter a value");
        //        subSp.Name = string.Format("subSp,{0}", globalPointer);
        //        subSp.Children.Add(tb);
        //        sp.Children.Add(subSp);

        //        Button but = new Button();
        //        but.Click += new RoutedEventHandler(btnAdd_Click);
        //        but.Content = "ADD";
        //        but.Style = Application.Current.Resources["Add"] as Style;
        //        but.Cursor = Cursors.Hand;
        //        but.Name = string.Format("but,{0}", globalPointer);
        //        but.Width = 70;
        //        but.Margin = new Thickness(4, 2, 2, 2);
        //        sp.Children.Add(but);
        //        pnlContainer.Children.Add(sp);
        //    }
        //}

        private void LayoutRoot_MouseLeftButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            // SlideIn.Begin();
        }

        private void LayoutRoot_MouseRightButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            // TODO: Add event handler implementation here.
        }

        /// <summary>
        /// Looks up the dataType for column.
        /// </summary>
        /// <param name="p"></param>
        /// <returns></returns>
        //private ColumnDataType LookUpDataType(Object col)
        //{
        //    string colName = ((EwavColumn)col).Name;
        //    IEnumerable<ColumnDataType> CBXFieldCols = from cols in applicationViewModel.EwavSelectedDatasource.AllColumns
        //                                               orderby cols.Name
        //                                               where cols.Name == colName
        //                                               select cols.SqlDataTypeAsString;

        //    List<ColumnDataType> listDT = CBXFieldCols.ToList<ColumnDataType>();
        //    return listDT[0];
        //}

        private void RectSlideIn_MouseLeftButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {


            if (dataFilterSlideCheck != false)
            {
                SlideIn.Begin();
                rotatearrow1.Begin();
                dataFilterSlideCheck = false;
            }
            else
            {
                SlideOut.Begin();
                rotatearrow.Begin();
                dataFilterSlideCheck = true;
            }

        }

        private void Slider_MouseEnter(object sender, MouseEventArgs e)
        {
            SlideOut.Begin();
            rotatearrow.Begin();
            dataFilterSlideCheck = true;
        }

        private void Slider_MouseLeave(object sender, MouseEventArgs e)
        {
        }

        /// <summary>
        /// Text Changed Event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void tb_TextChanged(object sender, TextChangedEventArgs e)
        {


            if (((TextBox)sender).Text != "")
            {
                btnApply.IsEnabled = true;
                //btnClear.IsEnabled = true;
            }






        }

        private void txtAdvancedFilter_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (pnlAdvancedMode.Visibility == System.Windows.Visibility.Visible)
            {
                //if (((TextBox)sender).Text != "")
                //{
                btnApply.IsEnabled = true;
                //btnClear.IsEnabled = true;
                //}
                //else
                //{
                //  btnApply.IsEnabled = false;
                //  btnClear.IsEnabled = false;
                //}
            }
        }
    }
}