﻿/*  ----------------------------------------------------------------------------
 *  Emergint Technologies, Inc.
 *  ----------------------------------------------------------------------------
 *  Epi Info™ - Web Analysis & Visualization
 *  ----------------------------------------------------------------------------
 *  File:       ConditionalAssign.xaml.cs
 *  Namespace:  Ewav    
 *
 *  Author(s):  Daniel Shorter, Mohammad Usman, Ninad Date, Sachin Agnihotri 
 *  Created:    26/08/2013    
 *  Summary:	no summary     
 *  ----------------------------------------------------------------------------
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using EpiDashboard;
using Ewav.BAL;
using Ewav.ViewModels;
using Ewav.Web.Services;
using Ewav.ExtensionMethods;
using CommonLibrary;
using System.Windows.Media.Imaging;
using System.Text;
using Ewav.Views.Gadgets;
//Serialize Method is written in Extensions.cs
namespace Ewav
{
    public partial class ConditionalAssign : ChildWindow, IEwavDashboardRule
    {
        bool editMode = false;
        List<EwavColumn> colsList;
        List<string> extractedList, operatorsList, configList;
        List<int> rowRemoved = new List<int>();
        List<EwavColumn> SourceColumns;
        int globalPointer, globalRemovedPointer = 0;
        public ApplicationViewModel applicationViewModel = ApplicationViewModel.Instance;
        StringBuilder conditionText = new StringBuilder();
        ListBoxItemSource SelectedItem;
        //EwavFilterControl ctrl;
        //EwavFilter UserControl;
        /// <summary>
        /// Default Constructor
        /// </summary>
        public ConditionalAssign()
        {
            InitializeComponent();
            if (this.applicationViewModel.EwavSelectedDatasource.AllColumns != null)
            {
                //initializeDataFilter();
                //ctrl = new EwavFilterControl();
                //ctrl.FilterType = FilterControlType.Conditional;
                //ctrl.MainPanel = pnlContainer;
                //ctrl.InitializeDataFilter();

                //UserControl = new EwavFilter();

                FilterCtrl.FilterType = FilterControlType.Conditional;
                FilterCtrl.InitializeDataFilter();

            }
            FillConditionalComboboxes();
            txtElseValue.IsEnabled = false;
            cmbElseValue.IsEnabled = false;
        }

        /// <summary>
        /// Parametrized Constructor for Edit functionality.
        /// </summary>
        /// <param name="editMode"></param>
        /// <param name="item"></param>
        public ConditionalAssign(bool editMode, ListBoxItemSource item)
        {
            InitializeComponent();
            this.editMode = editMode;
            SelectedItem = item;
            FillConditionalComboboxes();
            EwavRule_ConditionalAssign ca = (EwavRule_ConditionalAssign)SelectedItem.Rule;

            txtDestinationField.IsEnabled = false;
            cbxFieldType.SelectedIndex = SearchColumnIndex(cbxFieldType.Items, ca.CbxFieldType.ToString());
            cbxFieldType.IsEnabled = false;

            switch (cbxFieldType.SelectedValue.ToString().ToUpper().Replace("/", ""))
            {
                case "YESNO":
                    cmbAssignValue.SelectedIndex = SearchColumnIndex(cmbAssignValue.Items, (ca.AssignValue == "True") ? "Yes" : "No");
                    if (ca.ElseValue.Length > 0)
                    {
                        cmbElseValue.SelectedIndex = SearchColumnIndex(cmbElseValue.Items, (ca.ElseValue == "True") ? "Yes" : "No");
                    }

                    if (cmbElseValue.SelectedIndex > 0)
                    {
                        checkboxUseElse.IsChecked = true;
                    }
                    break;
                default:
                    txtAssignValue.Text = ca.AssignValue;
                    txtElseValue.Text = ca.ElseValue;
                    if (ca.ElseValue.Length > 0)
                    {
                        checkboxUseElse.IsChecked = true;
                    }
                    break;
            }

            if (checkboxUseElse.IsChecked == true)
            {
                txtElseValue.IsEnabled = true;
            }
            else
            {
                txtElseValue.IsEnabled = false;
            }

            txtDestinationField.Text = ca.TxtDestination;

            //FillSelectionComboboxes();

            pnlGuidedMode.Visibility = System.Windows.Visibility.Visible;
            //pnlBtns.Visibility = System.Windows.Visibility.Visible;
            pnlAdvancedMode.Visibility = System.Windows.Visibility.Collapsed;
            pnlContainer.Visibility = System.Windows.Visibility.Visible;

            //ctrl = new EwavFilterControl();
            FilterCtrl.FilterType = FilterControlType.Conditional;
            FilterCtrl.ConstructStackPanelFromDataFilters(((EwavRule_ConditionalAssign)SelectedItem.Rule).ConditionsList);

            
            //StackPanel sp = ctrl.MainPanel; //(StackPanel)SelectedItem.FilterConditionsPanel;

            //pnlContainer.Children.Clear();

            //for (int i = 0; i < sp.Children.Count; i++)
            //{
            //    StackPanel row = (StackPanel)sp.Children[i];
            //    sp.Children.RemoveAt(i);
            //    pnlContainer.Children.Add(row);
            //    i--; // Just because the count would change after RemoveAt
            //}
            //SelectedItem.FilterConditionsPanel = pnlContainer;
            //if (applicationViewModel.TempDataStorage.ContainsKey("FilterConditionalPanel"))
            //{
            //    applicationViewModel.TempDataStorage.Remove("FilterConditionalPanel");
            //}
            //applicationViewModel.TempDataStorage.Add("FilterConditionalPanel", (Object)SelectedItem.FilterConditionsPanel);
        }

        /// <summary>
        /// Validates the controls.
        /// </summary>
        /// <param name="stackPanel"></param>
        /// <returns></returns>
        public Boolean ValidateControl()
        {
            if (txtDestinationField.Text == "")
            {
                MessageBox.Show("Source Column is empty.");
                return false;
            }

            return FilterCtrl.ValidateControl();
            //TBD Validate the fileds from UserControl

            //if (editMode != false && applicationViewModel.TempDataStorage != null &&
            //       applicationViewModel.TempDataStorage.ContainsKey("FilterConditionalPanel"))
            //{
            //    pnlContainer = (StackPanel)applicationViewModel.TempDataStorage["FilterConditionalPanel"];
            //}

            //if (ctrl.MainPanel.Children.Count > 0)
            //{
            //    pnlContainer = ctrl.MainPanel;
            //}


            //bool value = true;
            //for (int j = 0; j < pnlContainer.Children.Count; j++)
            //{
            //    StackPanel child = (StackPanel)pnlContainer.Children[j];

            //    for (int k = 0; k < ((StackPanel)child).Children.Count; k++)
            //    {
            //        if (child.Children[k] is ComboBox && (((ComboBox)child.Children[k]).SelectedItem == null ||
            //            ((ComboBox)child.Children[k]).SelectedItem.ToString().Trim() == ""))
            //        {
            //            //var myElement = ((FrameworkElement)this.LayoutRoot).FindName("img" + j);
            //            //((Image)myElement).Visibility = System.Windows.Visibility.Visible;
            //            if (((ComboBox)child.Children[k]).IsEnabled)
            //            {
            //                MessageBox.Show("Some field(s) are empty.");
            //                return false;
            //            }

            //        }
            //        else if (child.Children[k] is StackPanel)
            //        {
            //            //return ValidateStackPanel((StackPanel)child.Children[k]);
            //            value = ValidateStackPanel((StackPanel)child.Children[k]);
            //        }
            //    }
            //}
            //return value;
        }

        /// <summary>
        /// Validates stackpanel
        /// </summary>
        /// <param name="sp"></param>
        /// <returns></returns>
        public bool ValidateStackPanel(StackPanel sp)
        {
            StackPanel stackPanel = sp;
            string spName = sp.Name;
            int j = Convert.ToInt32(spName.Substring(spName.IndexOf(",") + 1, spName.Length - spName.IndexOf(",") - 1));

            String s = string.Empty;

            for (int i = 0; i < stackPanel.Children.Count; i++)
            {
                if (stackPanel.Children[i] is TextBox && ((TextBox)stackPanel.Children[i]).Text == ""
                    && ((TextBox)stackPanel.Children[i]).IsEnabled)
                {
                    s += "No Data Entered in the Text Box" + "\n";
                }
                else if (stackPanel.Children[i] is ComboBox && ((ComboBox)stackPanel.Children[i]).SelectedIndex < 0
                    && ((ComboBox)stackPanel.Children[i]).IsEnabled)
                {
                    s += "No Selection has been made for combo Box" + "\n";
                }
                else if (stackPanel.Children[i] is DatePicker && ((DatePicker)stackPanel.Children[i]).Text == ""
                    && ((DatePicker)stackPanel.Children[i]).IsEnabled)
                {
                    s += "No Date selected." + "\n";
                }
            }
            if (s.Length > 0)
            {
                //var myElement = ((FrameworkElement)this.LayoutRoot).FindName("img" + j);
                //((Image)myElement).Visibility = System.Windows.Visibility.Visible;
                MessageBox.Show(s);
                return false;
            }
            //else
            //{
            //    var myElement = ((FrameworkElement)this.LayoutRoot).FindName("img" + j);
            //    ((Image)myElement).Visibility = System.Windows.Visibility.Collapsed;
            //}
            return true;
        }

        /// <summary>
        /// Searches for the index for the column.
        /// </summary>
        /// <param name="itemCollection"></param>
        /// <param name="myString"></param>
        /// <returns></returns>
        private int SearchColumnIndex(ItemCollection itemCollection, string myString)
        {
            int index = -1;

            for (int i = 0; i < itemCollection.Count; i++)
            {
                string columnNm = itemCollection[i].ToString().Replace("/", "");

                if (myString == columnNm)
                {
                    index = i;
                    break;
                }
            }
            return index;
        }

        /// <summary>
        /// Private Helper method that Fills the ComboBoxes on Conditional Assignment
        /// </summary>
        private void FillConditionalComboboxes()
        {
            txtDestinationField.Text = string.Empty;
            cbxFieldType.Items.Clear();

            List<string> fieldNames = new List<string>();

            //ColumnDataType columnDataType = ColumnDataType.Boolean | ColumnDataType.Numeric | ColumnDataType.Text | ColumnDataType.DateTime | ColumnDataType.UserDefined;
            //fieldNames = dashboardHelper.GetFieldsAsList(columnDataType);

            //fieldNames.Sort();

            cbxFieldType.Items.Add("Text");
            cbxFieldType.Items.Add("Numeric");
            cbxFieldType.Items.Add("Yes/No");
            cbxFieldType.SelectedIndex = 0;

            cmbAssignValue.Items.Add("Yes"); //(dashboardHelper.Config.Settings.RepresentationOfYes);
            cmbAssignValue.Items.Add("No"); //(dashboardHelper.Config.Settings.RepresentationOfNo);

            cmbElseValue.Items.Add("Yes"); //(dashboardHelper.Config.Settings.RepresentationOfYes);
            cmbElseValue.Items.Add("No"); //(dashboardHelper.Config.Settings.RepresentationOfNo);
        }

        /// <summary>
        /// Event Handler for FieldType Selection Changed. 
        /// Sets the visibility of Fields based upon selection
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cbxFieldType_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            switch (cbxFieldType.SelectedIndex)
            {
                case -1:
                    return;
                case 0:
                    txtAssignValue.Visibility = System.Windows.Visibility.Visible;
                    txtElseValue.Visibility = System.Windows.Visibility.Visible;
                    cmbAssignValue.Visibility = System.Windows.Visibility.Collapsed;
                    cmbElseValue.Visibility = System.Windows.Visibility.Collapsed;
                    break;
                case 1:
                    txtAssignValue.Visibility = System.Windows.Visibility.Visible;
                    txtElseValue.Visibility = System.Windows.Visibility.Visible;
                    cmbAssignValue.Visibility = System.Windows.Visibility.Collapsed;
                    cmbElseValue.Visibility = System.Windows.Visibility.Collapsed;
                    break;
                case 2:
                    txtAssignValue.Visibility = System.Windows.Visibility.Collapsed;
                    txtElseValue.Visibility = System.Windows.Visibility.Collapsed;
                    cmbAssignValue.Visibility = System.Windows.Visibility.Visible;
                    cmbElseValue.Visibility = System.Windows.Visibility.Visible;
                    break;
            }

            //cbxFieldType.Items.Add("Text");     0
            //cbxFieldType.Items.Add("Numeric");  1
            //cbxFieldType.Items.Add("Yes/No");   2
        }

        ///// <summary>
        ///// Initialize the grid for Data Filter.
        ///// </summary>
        //void initializeDataFilter()
        //{
        //    FillSelectionComboboxes();
        //    if (FindStackPanel(0, "sp") == null)
        //    {

        //        StackPanel sp = new StackPanel();
        //        sp.Orientation = Orientation.Horizontal;
        //        sp.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //        sp.Name = "sp" + "," + globalPointer;

        //        //TextBlock tblk = new TextBlock();
        //        //tblk.Text = "The Value of  ";
        //        //tblk.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //        //tblk.Margin = new Thickness(4, 2, 2, 2);
        //        //tblk.Name = "textblock" + globalPointer;
        //        //tblk.Width = 70;
        //        //sp.Children.Add(tblk);
        //        Image img = new Image();
        //        img.Name = "img" + globalPointer;
        //        img.Source = new BitmapImage(new Uri("../../Images/error.png", UriKind.Relative));
        //        img.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //        img.Margin = new Thickness(4, 2, 2, 2);
        //        img.Width = 16;
        //        img.Visibility = System.Windows.Visibility.Collapsed;
        //        sp.Children.Add(img);

        //        ComboBox cmb = new ComboBox();
        //        cmb.ItemsSource = extractedList;
        //        cmb.Margin = new Thickness(4, 2, 2, 2);
        //        cmb.SelectedIndex = 0;
        //        cmb.Width = 150;
        //        cmb.SelectionChanged += new SelectionChangedEventHandler(cmb_SelectionChanged);
        //        cmb.Name = "field" + "," + globalPointer;
        //        sp.Children.Add(cmb);

        //        cmb = new ComboBox();
        //        cmb.ItemsSource = operatorsList;
        //        cmb.Margin = new Thickness(4, 2, 2, 2);
        //        cmb.Width = 120;
        //        cmb.Name = "operator" + "," + globalPointer;
        //        cmb.SelectionChanged += new SelectionChangedEventHandler(cmbOp_SelectionChanged);
        //        sp.Children.Add(cmb);

        //        StackPanel subSp = new StackPanel();

        //        TextBox tb = new TextBox();
        //        tb.Width = 200;
        //        tb.Margin = new Thickness(4, 2, 2, 2);
        //        tb.Name = "tb" + "," + globalPointer;
        //        tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //        ToolTipService.SetToolTip(tb, "Please enter a value");
        //        subSp.Name = "subSp" + "," + globalPointer;
        //        subSp.Children.Add(tb);
        //        sp.Children.Add(subSp);

        //        Button but = new Button();
        //        but.Click += new RoutedEventHandler(btnAdd_Click);
        //        but.Content = "ADD";
        //        but.Style = Application.Current.Resources["Add"] as Style;
        //        but.Cursor = Cursors.Hand;
        //        but.Name = "but" + "," + globalPointer;
        //        but.Width = 70;
        //        but.Margin = new Thickness(4, 2, 2, 2);
        //        sp.Children.Add(but);
        //        pnlContainer.Children.Add(sp);
        //    }
        //}
        ///// <summary>
        ///// helper method that create and adds the row to dataFilter Grid
        ///// </summary>
        //private void CreateAndAddRow()
        //{
        //    globalPointer++;
        //    //btnClear.IsEnabled = true;

        //    StackPanel sp = new StackPanel();
        //    sp.Orientation = Orientation.Horizontal;
        //    sp.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //    sp.Name = "sp" + "," + globalPointer;

        //    //TextBlock tblk = new TextBlock();
        //    //tblk.Text = "The Value of  ";
        //    //tblk.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //    //tblk.Name = "textblock" + globalPointer;
        //    //tblk.Width = 70;
        //    //tblk.Margin = new Thickness(4, 2, 2, 2);
        //    //sp.Children.Add(tblk);

        //    Image img = new Image();
        //    img.Name = "img" + globalPointer;
        //    img.Source = new BitmapImage(new Uri("../../Images/error.png", UriKind.Relative));
        //    img.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //    img.Margin = new Thickness(4, 2, 2, 2);
        //    img.Width = 16;
        //    img.Visibility = System.Windows.Visibility.Collapsed;
        //    sp.Children.Add(img);

        //    ComboBox cmb = new ComboBox();
        //    cmb.ItemsSource = extractedList;
        //    cmb.Name = "field" + "," + globalPointer;
        //    cmb.Width = 150;
        //    cmb.Margin = new Thickness(4, 2, 2, 2);
        //    cmb.SelectedIndex = 0;
        //    cmb.SelectionChanged += new SelectionChangedEventHandler(cmb_SelectionChanged);
        //    sp.Children.Add(cmb);

        //    ComboBox cmb1 = new ComboBox();
        //    cmb1.ItemsSource = operatorsList;
        //    cmb1.Name = "operator" + "," + globalPointer;
        //    cmb1.SelectionChanged += new SelectionChangedEventHandler(cmbOp_SelectionChanged);
        //    cmb1.Width = 120;
        //    cmb1.Margin = new Thickness(4, 2, 2, 2);
        //    sp.Children.Add(cmb1);

        //    StackPanel subSp = new StackPanel();
        //    subSp.Orientation = Orientation.Horizontal;
        //    subSp.VerticalAlignment = System.Windows.VerticalAlignment.Center;


        //    TextBox tb = new TextBox();
        //    tb.Name = "tb" + "," + globalPointer;
        //    tb.Width = 200;
        //    tb.Margin = new Thickness(4, 2, 2, 2);
        //    tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //    subSp.Name = "subSp" + "," + globalPointer;
        //    subSp.Children.Add(tb);
        //    sp.Children.Add(subSp);

        //    Button but = new Button();
        //    but.Click += new RoutedEventHandler(btnAdd_Click);
        //    but.Content = "ADD";
        //    but.Style = Application.Current.Resources["Add"] as Style;
        //    but.Cursor = Cursors.Hand;
        //    but.Name = "but" + "," + globalPointer;
        //    //but.Width = 70;
        //    but.Margin = new Thickness(4, 2, 2, 2);
        //    sp.Children.Add(but);
        //    pnlContainer.Children.Add(sp);
        //    //filterCount.Text = string.Format("Data Filter ({0})", globalPointer - globalRemovedPointer);
        //}

        ///// <summary>
        ///// Helper method Finds the Control in Row
        ///// </summary>
        ///// <param name="rowNumber"></param>
        ///// <param name="controlName"></param>
        ///// <param name="deep"></param>
        ///// <returns></returns>
        //private Control FindControlInRow(int rowNumber, string controlName, bool deep = false)
        //{
        //    StackPanel sp;
        //    if (deep)
        //    {
        //        sp = ((StackPanel)FindStackPanel(rowNumber, "subSp", true));
        //    }
        //    else
        //    {
        //        sp = ((StackPanel)FindStackPanel(rowNumber, "sp"));
        //    }
        //    int count = VisualTreeHelper.GetChildrenCount(sp);
        //    for (int i = 0; i < count; i++)
        //    {
        //        var child = VisualTreeHelper.GetChild(sp, i);
        //        if (child is Control)
        //        {
        //            if (((Control)child).Name.Contains(controlName))
        //            {
        //                return (Control)child;
        //            }
        //        }
        //    }
        //    return null;
        //}

        ///// <summary>
        ///// Finds the stackpanel
        ///// </summary>
        ///// <param name="rowNumber"></param>
        ///// <param name="controlName"></param>
        ///// <param name="deep"></param>
        ///// <returns></returns>
        //private StackPanel FindStackPanel(int rowNumber, string controlName, bool deep = false)
        //{
        //    StackPanel sp;
        //    if (deep)
        //    {
        //        sp = FindStackPanel(rowNumber, "sp");
        //    }
        //    else
        //    {
        //        //applicationViewModel.TempDataStorage.Add("FilterConditionalPanel", (Object)SelectedItem.FilterConditionsPanel);
        //        if (editMode != false && applicationViewModel.TempDataStorage != null &&
        //            applicationViewModel.TempDataStorage.ContainsKey("FilterConditionalPanel"))
        //        {
        //            sp = (StackPanel)applicationViewModel.TempDataStorage["FilterConditionalPanel"];
        //        }
        //        else
        //        {
        //            sp = pnlContainer;
        //        }

        //    }
        //    int count = VisualTreeHelper.GetChildrenCount(sp);
        //    for (int i = 0; i < count; i++)
        //    {
        //        var child = VisualTreeHelper.GetChild(sp, i);
        //        if (child is StackPanel)
        //        {
        //            if (((StackPanel)child).Name.Contains(controlName + "," + rowNumber))
        //            {
        //                return (StackPanel)child;
        //            }
        //        }
        //    }
        //    return null;
        //}

        ///// <summary>
        ///// Fills the comboboxes for dataFilter Grid
        ///// </summary>
        //public void FillSelectionComboboxes()
        //{
        //    SourceColumns = this.applicationViewModel.EwavSelectedDatasource.AllColumns;
        //    extractedList = new List<string>();
        //    operatorsList = new List<string>();
        //    configList = new List<string>();

        //    //List<ColumnDataType> columnDataType = new List<ColumnDataType>();
        //    //columnDataType.Add(ColumnDataType.Boolean);
        //    //columnDataType.Add(ColumnDataType.Numeric);
        //    //columnDataType.Add(ColumnDataType.DateTime);
        //    //columnDataType.Add(ColumnDataType.Text);

        //    IEnumerable<EwavColumn> CBXFieldCols = from cols in SourceColumns
        //                                           orderby cols.Name
        //                                           select cols;

        //    colsList = CBXFieldCols.ToList();

        //    colsList.Insert(0, new EwavColumn() { Name = " ", Index = -1 });

        //    for (int i = 0; i < colsList.Count; i++)
        //    {
        //        extractedList.Add(colsList[i].Name);
        //    }
        //}

        ///// <summary>
        ///// Fills the comboBoex for Operator ComboBoxex
        ///// </summary>
        ///// <param name="field"></param>
        //private void FillOperatorValues(ColumnDataType field)
        //{


        //    operatorsList.Clear();

        //    // Set operator drop-down values
        //    if (field == ColumnDataType.Numeric || field == ColumnDataType.DateTime)
        //    {
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_EQUAL_TO);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_BETWEEN);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_LESS_THAN);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_GREATER_THAN);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_LESS_THAN_OR_EQUAL);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_GREATER_THAN_OR_EQUAL);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING);
        //    }
        //    else if (field == ColumnDataType.Boolean)
        //    {
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_EQUAL_TO);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING);

        //        configList.Add("Yes");
        //        configList.Add("No");
        //        configList.Add("Missing");
        //    }
        //    else if (field == ColumnDataType.Text)
        //    {
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_EQUAL_TO);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_LIKE);
        //        operatorsList.Add(SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING);
        //    }

        //}

        ///// <summary>
        ///// Looks up the dataType for selected column
        ///// </summary>
        ///// <param name="p"></param>
        ///// <returns></returns>
        //private ColumnDataType LookUpDataType(string selectedColumn)
        //{
        //    IEnumerable<ColumnDataType> CBXFieldCols = from cols in SourceColumns
        //                                               orderby cols.Name
        //                                               where cols.Name == selectedColumn
        //                                               select cols.SqlDataTypeAsString;

        //    List<ColumnDataType> listDT = CBXFieldCols.ToList<ColumnDataType>();
        //    return listDT[0];
        //}

        ///// <summary>
        ///// Handler responds to textChanged event 
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void tb_TextChanged(object sender, TextChangedEventArgs e)
        //{
        //    if (((TextBox)sender).Text != "")
        //    {
        //        btnApply.IsEnabled = true;
        //        //btnClear.IsEnabled = true;
        //    }

        //}

        ///// <summary>
        ///// Handler responds to Add Click event. 
        ///// Adds a row in Data Filter Control
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void btnAdd_Click(object sender, RoutedEventArgs e)
        //{
        //    if (pnlContainer.Children.Count == 0)
        //    {
        //        pnlContainer = (StackPanel)((StackPanel)((Button)sender).Parent).Parent;
        //    }

        //    string buttonName = ((Button)sender).Name;
        //    int rowNumber = Convert.ToInt32(buttonName.Substring(buttonName.IndexOf(",") + 1, buttonName.Length - buttonName.IndexOf(",") - 1));
        //    ((StackPanel)pnlContainer.Children[rowNumber - globalRemovedPointer]).Children.Remove(FindControlInRow(rowNumber, "but"));

        //    ComboBox cmbJoinType = new ComboBox();
        //    cmbJoinType.Name = "cmbJoinType, " + globalPointer;

        //    cmbJoinType.Items.Add(JoinType.AND);
        //    cmbJoinType.Items.Add(JoinType.OR);
        //    cmbJoinType.Width = 58;
        //    cmbJoinType.Margin = new Thickness(4, 2, 2, 2);
        //    cmbJoinType.SelectedIndex = 0;
        //    cmbJoinType.SelectionChanged += new SelectionChangedEventHandler(cmbJoinType_SelectionChanged);
        //    ((StackPanel)pnlContainer.Children[rowNumber - globalRemovedPointer]).Children.Add(cmbJoinType);


        //    Button butRemove = new Button();
        //    butRemove.Name = "btnRemove," + globalPointer;
        //    butRemove.Content = "X";
        //    butRemove.HorizontalAlignment = System.Windows.HorizontalAlignment.Right;
        //    //butRemove.Width = 14;
        //    //butRemove.Height = 14;
        //    butRemove.Click += new RoutedEventHandler(butRemove_Click);
        //    butRemove.Style = Application.Current.Resources["Remove2"] as Style;
        //    butRemove.HorizontalAlignment = System.Windows.HorizontalAlignment.Right;
        //    butRemove.Cursor = Cursors.Hand;
        //    //butRemove.Margin = new Thickness(0, 5, 47, -2);
        //    butRemove.Margin = new Thickness(4, 2, 2, 2);

        //    ((StackPanel)pnlContainer.Children[rowNumber - globalRemovedPointer]).Children.Add(butRemove);

        //    //filterCount.Text = filterCount.Text + " * ";
        //    CreateAndAddRow();
        //    scroll_content.UpdateLayout();
        //    scroll_content.ScrollToVerticalOffset(double.MaxValue);
        //    btnApply.IsEnabled = true;
        //}

        ///// <summary>
        ///// Responds to selectionChanged Event of Join Type ComboBox
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void cmbJoinType_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    btnApply.IsEnabled = true;
        //}

        ///// <summary>
        ///// Responds to Remove Click
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void butRemove_Click(object sender, RoutedEventArgs e)
        //{
        //    string buttonName = ((Button)sender).Name;
        //    int rowNumber = Convert.ToInt32(buttonName.Substring(buttonName.IndexOf(",") + 1, buttonName.Length - buttonName.IndexOf(",") - 1));
        //    if (pnlContainer.Children.Count == 0)
        //    {
        //        StackPanel pnlC = (StackPanel)applicationViewModel.TempDataStorage["FilterConditionalPanel"];
        //        pnlC.Children.Remove(FindStackPanel(rowNumber, "sp"));
        //    }
        //    else
        //    {
        //        pnlContainer.Children.Remove(FindStackPanel(rowNumber, "sp"));
        //    }

        //    rowRemoved.Add(rowNumber);
        //    btnApply.IsEnabled = true;
        //    globalRemovedPointer++;
        //}

        ///// <summary>
        ///// responds to Field SelectionChanged Event.
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void cmb_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    if (((ComboBox)sender).SelectedItem != null && ((ComboBox)sender).SelectedItem.ToString().Trim() != "")
        //    {

        //        ColumnDataType dataType = LookUpDataType(((ComboBox)sender).SelectedItem.ToString());

        //        int rowNumber = Convert.ToInt32(((ComboBox)sender).Name.ToString().Split(new Char[] { ',' })[1]);

        //        FillOperatorValues(dataType);
        //        string controlName = "operator";
        //        Control elemnt = FindControlInRow(rowNumber, controlName);
        //        if (elemnt != null)
        //        {
        //            ((ComboBox)elemnt).ItemsSource = null;
        //            ((ComboBox)elemnt).ItemsSource = operatorsList;
        //        }
        //    }
        //    btnApply.IsEnabled = true;
        //}

        ///// <summary>
        ///// Responds to Operator Selection Chnaged Event.
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void cmbOp_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{

        //    btnApply.IsEnabled = true;
        //    if (((ComboBox)sender).SelectedItem != null)
        //    {
        //        int rowNumber = Convert.ToInt32(((ComboBox)sender).Name.ToString().Split(new Char[] { ',' })[1]);
        //        ColumnDataType dataType = LookUpDataType(((ComboBox)FindControlInRow(rowNumber, "field")).SelectedItem.ToString());

        //        StackPanel subSp = new StackPanel();
        //        subSp.Name = "subSp" + "," + globalPointer;
        //        string operatorSelected = ((ComboBox)sender).SelectedItem.ToString();

        //        StackPanel ctrlContainer = new StackPanel();
        //        ctrlContainer = FindStackPanel(rowNumber, "subSp", true);
        //        ctrlContainer.Children.Clear();
        //        ctrlContainer.Orientation = Orientation.Horizontal;

        //        switch (dataType)
        //        {
        //            case ColumnDataType.Text:

        //                TextBox tb = new TextBox();
        //                tb.Width = 200;
        //                tb.Margin = new Thickness(4, 2, 2, 2);
        //                tb.Name = "tb" + "," + rowNumber;
        //                tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //                tb.IsEnabled = SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING == operatorSelected ? false : true;
        //                ctrlContainer.Name = "subSp" + "," + rowNumber;
        //                ctrlContainer.Children.Add(tb);
        //                break;
        //            case ColumnDataType.Numeric:
        //                if (SharedStrings.FRIENDLY_OPERATOR_BETWEEN == operatorSelected)
        //                {
        //                    tb = new TextBox();
        //                    tb.Name = "tb" + rowNumber + "1";
        //                    tb.Width = 83;
        //                    tb.Margin = new Thickness(4, 2, 2, 2);
        //                    tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //                    ctrlContainer.Name = "subSp" + "," + rowNumber;
        //                    ctrlContainer.Children.Add(tb);
        //                    TextBlock tblk = new TextBlock();
        //                    tblk.Name = "between" + rowNumber;
        //                    //tblk.Width = 40;
        //                    tblk.Text = " and ";
        //                    tblk.Margin = new Thickness(0, 0, 1, 0);
        //                    tblk.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //                    ctrlContainer.Children.Add(tblk);
        //                    tb = new TextBox();
        //                    tb.Name = "tb" + rowNumber + "2";
        //                    tb.Width = 83;
        //                    tb.Margin = new Thickness(4, 2, 2, 2);
        //                    tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //                    ctrlContainer.Children.Add(tb);
        //                }
        //                else
        //                {
        //                    tb = new TextBox();
        //                    tb.Width = 200;
        //                    tb.Margin = new Thickness(4, 2, 2, 2);
        //                    tb.Name = "tb" + "," + rowNumber;
        //                    tb.TextChanged += new TextChangedEventHandler(tb_TextChanged);
        //                    tb.IsEnabled = SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING == operatorSelected ? false : true;
        //                    ctrlContainer.Name = "subSp" + "," + rowNumber;
        //                    ctrlContainer.Children.Add(tb);
        //                }
        //                break;
        //            case ColumnDataType.Boolean:
        //                ComboBox cmbBool = new ComboBox();
        //                cmbBool.Name = "value" + globalPointer;
        //                cmbBool.Width = 200;
        //                cmbBool.Margin = new Thickness(4, 2, 2, 2);
        //                cmbBool.Items.Add("YES");
        //                cmbBool.Items.Add("NO");
        //                cmbBool.Items.Add("Missing");
        //                cmbBool.SelectionChanged += new SelectionChangedEventHandler(cmbBool_SelectionChanged);

        //                if (((ComboBox)sender).SelectedItem.ToString() == SharedStrings.FRIENDLY_OPERATOR_NOT_MISSING)
        //                {
        //                    cmbBool.IsEnabled = false;
        //                }
        //                else
        //                {
        //                    cmbBool.IsEnabled = true;
        //                }
        //                ctrlContainer.Name = "subSp" + "," + rowNumber;
        //                ctrlContainer.Children.Add(cmbBool);
        //                break;
        //            case ColumnDataType.DateTime:
        //                if (SharedStrings.FRIENDLY_OPERATOR_BETWEEN == operatorSelected)
        //                {
        //                    DatePicker dp = new DatePicker();
        //                    dp.Name = "dp" + rowNumber + "1";
        //                    //dp.Width = 95;
        //                    dp.Style = Application.Current.Resources["dpbetween"] as Style;
        //                    dp.Margin = new Thickness(4, 2, 14, 2);

        //                    dp.SelectedDateChanged += new EventHandler<SelectionChangedEventArgs>(dp_SelectedDateChanged);
        //                    ctrlContainer.Name = "subSp" + "," + rowNumber;
        //                    ctrlContainer.Children.Add(dp);
        //                    TextBlock tblk = new TextBlock();
        //                    tblk.Name = "between" + rowNumber;
        //                    //tblk.Width = 20;
        //                    tblk.Text = " - ";
        //                    tblk.VerticalAlignment = System.Windows.VerticalAlignment.Center;
        //                    ctrlContainer.Children.Add(tblk);
        //                    dp = new DatePicker();
        //                    dp.Name = "dp" + rowNumber + "2";
        //                    //dp.Width = 95;
        //                    dp.Style = Application.Current.Resources["dpbetween"] as Style;
        //                    dp.Margin = new Thickness(4, 2, 14, 2);
        //                    dp.SelectedDateChanged += new EventHandler<SelectionChangedEventArgs>(dp_SelectedDateChanged);

        //                    ctrlContainer.Children.Add(dp);
        //                }
        //                else
        //                {
        //                    DatePicker dp = new DatePicker();
        //                    dp.Name = "datep," + rowNumber;
        //                    dp.Width = 190;
        //                    dp.Style = Application.Current.Resources["dpbetween"] as Style;
        //                    dp.Margin = new Thickness(4, 2, 12, 2);
        //                    dp.SelectedDateChanged += new EventHandler<SelectionChangedEventArgs>(dp_SelectedDateChanged);
        //                    ctrlContainer.Name = "subSp" + "," + rowNumber;
        //                    ctrlContainer.Children.Add(dp);
        //                }
        //                break;
        //            case ColumnDataType.UserDefined:
        //                break;
        //            default:
        //                break;
        //        }

        //    }

        //}

        ///// <summary>
        ///// Responds to selection Changed Event of Bool, YES/NO field.
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void cmbBool_SelectionChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    btnApply.IsEnabled = true;
        //}

        ///// <summary>
        ///// DatePicker Selection Changed event.
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //void dp_SelectedDateChanged(object sender, SelectionChangedEventArgs e)
        //{
        //    btnApply.IsEnabled = true;
        //}

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            List<ListBoxItemSource> TempList = applicationViewModel.ListOfRules.Where(t => t.DestinationColumn.ToLower() == txtDestinationField.Text.ToLower()).ToList();

            Boolean columnNameExists = false;
            columnNameExists = applicationViewModel.EwavSelectedDatasource.AllColumns.Any(c => c.Name.ToLower() == txtDestinationField.Text.ToLower());

            if ((TempList.Count > 0 && !editMode) || columnNameExists)
            {
                MessageBox.Show("Variable name already exists.");
                return;
            }


            if (ValidateControl())
            {
                //if (applicationViewModel.TempDataStorage.Count > 0)
                //{
                //    ctrl = new EwavFilterControl();
                //    ctrl.FilterType = FilterControlType.Conditional;
                //    //ctrl.MainPanel = (StackPanel)applicationViewModel.TempDataStorage["FilterConditionalPanel"];
                //    //ctrl.InitializeDataFilter();
                //}

                //if (ctrl.MainPanel.Children.Count == 0)
                //{
                //    ctrl.ConstructStackPanelFromDataFilters(((EwavRule_ConditionalAssign)SelectedItem.Rule).ConditionsList);
                //}

                //FilterCtrl.Conditions = ((EwavRule_ConditionalAssign)SelectedItem.Rule).ConditionsList;

                List<EwavDataFilterCondition> listOfFilters = FilterCtrl.CreateDataFilters();

                string destinationColumnType = "System.String";

                ColumnDataType colType = ColumnDataType.Text;

                object elseValue = this.txtElseValue.Text;
                object assignValue = this.txtAssignValue.Text;
                cbxFieldTypeEnum fieldEnum = cbxFieldTypeEnum.None;
                switch (cbxFieldType.SelectedItem.ToString())
                {
                    case "Yes/No":
                        destinationColumnType = "System.Boolean";
                        if (cmbAssignValue.SelectedIndex == 0)
                        {
                            assignValue = true;
                        }
                        else if (cmbAssignValue.SelectedIndex == 1)
                        {
                            assignValue = false;
                        }

                        if (checkboxUseElse.IsChecked == false)
                        {
                            elseValue = "";
                        }
                        else if (cmbElseValue.SelectedIndex == 0)
                        {
                            elseValue = true;
                        }
                        else if (cmbElseValue.SelectedIndex == 1)
                        {
                            elseValue = false;
                        }
                        fieldEnum = cbxFieldTypeEnum.YesNo;
                        colType = ColumnDataType.Boolean;
                        break;
                    case "Text":
                        destinationColumnType = "System.String";
                        if (checkboxUseElse.IsChecked == false)
                        {
                            elseValue = "";
                        }
                        else
                        {
                            elseValue = this.txtElseValue.Text;
                        }

                        assignValue = this.txtAssignValue.Text;
                        fieldEnum = cbxFieldTypeEnum.Text;
                        colType = ColumnDataType.Text;
                        break;
                    case "Numeric":
                        destinationColumnType = "System.Decimal";
                        decimal decElse;
                        decimal decAssign;
                        if (checkboxUseElse.IsChecked == false)
                        {
                            elseValue = "";
                        }
                        else
                        {
                            bool success1 = Decimal.TryParse(this.txtElseValue.Text, out decElse);
                            if (success1) elseValue = decElse;
                        }

                        bool success2 = Decimal.TryParse(this.txtAssignValue.Text, out decAssign);
                        if (success2) assignValue = decAssign;

                        //if ((!success1 && checkboxUseElse.IsChecked) || !success2)
                        //{
                        //    Epi.Windows.MsgBox.ShowError("Invalid input detected.");
                        //    this.DialogResult = DialogResult.None;
                        //    return;
                        //}
                        fieldEnum = cbxFieldTypeEnum.Numeric;
                        colType = ColumnDataType.Numeric;
                        break;
                }

                string assignText = FilterCtrl.ConditionText.ToString().Substring(0, FilterCtrl.ConditionText.Length - 3);

                if (checkboxUseElse.IsChecked == true)
                {
                    assignText += ". Otherwise, assign " + txtDestinationField.Text + " the value " + elseValue + ".";
                }
                //conditionText = ( 

                ListBoxItemSource listBoxItem = new ListBoxItemSource();
                listBoxItem.RuleString = "Assign " + txtDestinationField.Text + " the value " + assignValue + " when " + assignText;
                listBoxItem.SourceColumn = null;
                listBoxItem.DestinationColumn = txtDestinationField.Text;
                listBoxItem.RuleType = EwavRuleType.conditional;

                EwavRule_ConditionalAssign rule = new EwavRule_ConditionalAssign();
                rule.TxtDestination = txtDestinationField.Text;
                rule.DestinationColumnType = destinationColumnType;
                rule.AssignValue = assignValue.ToString();
                rule.ElseValue = elseValue.ToString();
                rule.ConditionsList = listOfFilters;
                rule.CbxFieldType = fieldEnum;
                rule.VaraiableName = txtDestinationField.Text;
                rule.VaraiableDataType = colType.ToString();

                MyString tempStr = new MyString();
                tempStr.VarName = "Assign " + txtDestinationField.Text + " the value " + assignValue + " when " + assignText;
                rule.FriendlyRule = tempStr;

                EwavColumn newColumn = new EwavColumn();
                newColumn.Name = txtDestinationField.Text;
                newColumn.SqlDataTypeAsString = colType;// ColumnDataType.Text;
                newColumn.NoCamelName = txtDestinationField.Text;
                newColumn.IsUserDefined = true;

                applicationViewModel.InvokePreColumnChangedEvent();



                List<EwavRule_Base> rules = new List<EwavRule_Base>();
                rules = applicationViewModel.EwavDefinedVariables;
                listBoxItem.Rule = rule;
                //listBoxItem.FilterConditionsPanel = pnlContainer;

                //Shows the error message if name already exists.
                if (!editMode)
                {
                    for (int i = 0; i < applicationViewModel.EwavDefinedVariables.Count; i++)
                    {
                        if (applicationViewModel.EwavDefinedVariables[i].VaraiableName == rule.VaraiableName)
                        {
                            MessageBox.Show("Rule Name already exists. Select another name.");
                            return;
                        }
                    }
                }

                for (int i = 0; i < rules.Count; i++)
                {
                    if (rule.TxtDestination == rules[i].VaraiableName)
                    {
                        rules[i] = rule;
                        //applicationViewModel.ListOfRules.RemoveAt(i);
                        applicationViewModel.ListOfRules[i] = listBoxItem;
                        break;
                    }
                }

                if (!editMode)
                {
                    applicationViewModel.EwavSelectedDatasource.AllColumns.Add(newColumn);
                    applicationViewModel.ListOfRules.Add(listBoxItem);
                    rules.Add(rule);
                }

                applicationViewModel.EwavDefinedVariables = rules;

                this.DialogResult = true;
            }
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }

        private void btnIfCondition_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            // TODO: Add event handler implementation here.
            pnlGuidedMode.Visibility = System.Windows.Visibility.Visible;
            //pnlBtns.Visibility = System.Windows.Visibility.Visible;
            pnlAdvancedMode.Visibility = System.Windows.Visibility.Collapsed;
            pnlContainer.Visibility = System.Windows.Visibility.Visible;

        }

        private void btnApply_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            // TODO: Add event handler implementation here.
            pnlGuidedMode.Visibility = System.Windows.Visibility.Collapsed;
            //pnlBtns.Visibility = System.Windows.Visibility.Collapsed;
            pnlAdvancedMode.Visibility = System.Windows.Visibility.Visible;
        }

        ///// <summary>
        ///// Method that creates dataFilter
        ///// </summary>
        ///// <returns></returns>
        //public List<EwavDataFilterCondition> CreateDataFilters()
        //{
        //    List<EwavDataFilterCondition> filtercondList = new List<EwavDataFilterCondition>();
        //    int childCount = pnlContainer.Children.Count;

        //    for (int i = 0; i < childCount; i++)
        //    {
        //        UIElementCollection listOfCtrl = ((StackPanel)pnlContainer.Children[i]).Children;

        //        ColumnDataType dataType = LookUpDataType(((ComboBox)listOfCtrl[1]).SelectedItem.ToString());
        //        string operatorSelected = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString();
        //        switch (dataType)
        //        {

        //            case ColumnDataType.Text:


        //                EwavDataFilterCondition condition = new EwavDataFilterCondition()
        //                  {
        //                      FieldName = ((ComboBox)listOfCtrl[1]).SelectedItem.ToString().ToMyString(),
        //                      FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                      FriendlyValue = ((TextBox)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                      JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                  };
        //                filtercondList.Add(condition);

        //                conditionText.Append("The Value of " + condition.FieldName.VarName + " " +
        //                    condition.FriendlyOperand.VarName + " " +
        //                    condition.FriendlyValue.VarName + " " +
        //                   condition.JoinType.VarName);
        //                break;
        //            case ColumnDataType.Numeric:
        //                if (SharedStrings.FRIENDLY_OPERATOR_BETWEEN == operatorSelected)
        //                {
        //                    condition =
        //                     new EwavDataFilterCondition()
        //                     {
        //                         FieldName = ((ComboBox)listOfCtrl[1]).SelectedItem.ToString().ToMyString(),
        //                         FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                         FriendLowValue = ((TextBox)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                         FriendHighValue = ((TextBox)((StackPanel)listOfCtrl[3]).Children[2]).Text.ToString().ToMyString(),
        //                         JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                     };
        //                    filtercondList.Add(condition);
        //                    conditionText.Append("The Value of " + condition.FieldName.VarName + " " +
        //                    condition.FriendlyOperand.VarName + " " +
        //                    condition.FriendLowValue.VarName + " " +
        //                    condition.FriendHighValue.VarName + " " +
        //                   condition.JoinType.VarName);
        //                }
        //                else
        //                {

        //                    condition =
        //                       new EwavDataFilterCondition()
        //                       {
        //                           FieldName = ((ComboBox)listOfCtrl[1]).SelectedItem.ToString().ToMyString(),
        //                           FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                           FriendlyValue = ((TextBox)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                           JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                       };
        //                    filtercondList.Add(condition);
        //                    conditionText.Append("The Value of " + condition.FieldName.VarName + " " +
        //                  condition.FriendlyOperand.VarName + " " +
        //                  condition.FriendlyValue.VarName + " " +
        //                 condition.JoinType.VarName);

        //                }
        //                break;
        //            case ColumnDataType.Boolean:
        //                MyString fValue;
        //                if (((ComboBox)((StackPanel)listOfCtrl[3]).Children[0]).IsEnabled)
        //                {
        //                    if (((ComboBox)((StackPanel)listOfCtrl[3]).Children[0]).SelectedItem.ToString().ToUpper() == "MISSING")
        //                    {
        //                        fValue = "missing".ToMyString();
        //                    }
        //                    else
        //                    {
        //                        fValue = ((ComboBox)((StackPanel)listOfCtrl[3]).Children[0]).SelectedItem.ToString().ToMyString();
        //                    }
        //                }
        //                else
        //                {
        //                    fValue = new MyString();
        //                }

        //                condition =
        //                   new EwavDataFilterCondition()
        //                   {
        //                       FieldName = ((ComboBox)listOfCtrl[1]).SelectedItem.ToString().ToMyString(),
        //                       FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                       FriendlyValue = fValue,
        //                       JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                   };
        //                filtercondList.Add(condition);
        //                conditionText.Append("The Value of " + condition.FieldName.VarName + " " +
        //              condition.FriendlyOperand.VarName + " " +
        //              condition.FriendlyValue.VarName + " " +
        //             condition.JoinType.VarName);

        //                break;
        //            case ColumnDataType.DateTime:
        //                if (SharedStrings.FRIENDLY_OPERATOR_BETWEEN == operatorSelected)
        //                {

        //                    condition =
        //                      new EwavDataFilterCondition()
        //                      {
        //                          FieldName = ((ComboBox)listOfCtrl[1]).SelectedItem.ToString().ToMyString(),
        //                          FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                          FriendLowValue = ((DatePicker)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                          FriendHighValue = ((DatePicker)((StackPanel)listOfCtrl[3]).Children[2]).Text.ToString().ToMyString(),
        //                          JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                      };
        //                    filtercondList.Add(condition);
        //                    conditionText.Append("The Value of " + condition.FieldName.VarName + " " +
        //                    condition.FriendlyOperand.VarName + " " +
        //                    condition.FriendLowValue.VarName + " " +
        //                    condition.FriendHighValue.VarName + " " +
        //                   condition.JoinType.VarName);
        //                }
        //                else
        //                {

        //                    condition =
        //                       new EwavDataFilterCondition()
        //                       {
        //                           FieldName = ((ComboBox)listOfCtrl[1]).SelectedItem.ToString().ToMyString(),
        //                           FriendlyOperand = ((ComboBox)listOfCtrl[2]).SelectedItem.ToString().ToMyString(),
        //                           FriendlyValue = ((DatePicker)((StackPanel)listOfCtrl[3]).Children[0]).Text.ToString().ToMyString(),
        //                           JoinType = (listOfCtrl[4] is ComboBox) ? ((ComboBox)listOfCtrl[4]).SelectedItem.ToString().ToMyString() : "AND".ToMyString()
        //                       };
        //                    filtercondList.Add(condition);
        //                    conditionText.Append("The Value of " + condition.FieldName.VarName + " " +
        //                 condition.FriendlyOperand.VarName + " " +
        //                 condition.FriendlyValue.VarName + " " +
        //                condition.JoinType.VarName);
        //                }
        //                break;
        //            case ColumnDataType.UserDefined:
        //                break;
        //            default:
        //                break;
        //        }
        //    }


        //    return filtercondList;
        //}


        private void checkboxUseElse_Checked(object sender, RoutedEventArgs e)
        {
            txtElseValue.IsEnabled = true;
            cmbElseValue.IsEnabled = true;
        }

        private void checkboxUseElse_Unchecked(object sender, RoutedEventArgs e)
        {
            txtElseValue.IsEnabled = false;
            cmbElseValue.IsEnabled = false;
        }

        void IEwavDashboardRule.CreateFromXml(System.Xml.Linq.XElement element)
        {
            throw new NotImplementedException();
        }
    }
}